﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using VDS.RDF.Query;

namespace DBpediaGetCityCounty
{
	class Program
	{
		static void GetCityCountry()
		{
			//First define a SPARQL Endpoint for DBPedia
			//SparqlRemoteEndpoint endpoint = new SparqlRemoteEndpoint(new Uri("http://dbpedia.org/sparql"));
			SparqlRemoteEndpoint endpoint = new SparqlRemoteEndpoint(new Uri("http://dbpedia-live.openlinksw.com/sparql/"));

			StringBuilder output = new StringBuilder();
			int offset = 0;
			try
			{
				while (true) {
					string query =
						string.Format(@"SELECT ?cityLabel ?countryLabel ?city ?country ?url ?countryUrl  WHERE {{
	?city rdf:type <http://dbpedia.org/ontology/City>;
		foaf:isPrimaryTopicOf ?url;
		dbpedia-owl:country ?country.
	?country foaf:isPrimaryTopicOf ?countryUrl.
	?city rdfs:label ?cityLabel.
	?country rdfs:label ?countryLabel.
	FILTER (lang(?cityLabel) = ""en"" && lang(?countryLabel) = ""en"" )
	}}
	LIMIT 100
	OFFSET {0}", offset);

					SparqlResultSet res = endpoint.QueryWithResultSet(query);
					foreach (var r in res)
						output.Append(r[0].ToString().Replace("@en", "") + "\t" + r[1].ToString().Replace("@en", "") + "\t" + r[4] + "\t" + r[5] + "\n");
					offset += 100;
					Console.Write(String.Format("Offset: {0}\r", offset));
					if (res.Count == 0)
						break;
				}
			}
			catch (Exception e)
			{
				Console.WriteLine(e);
				Console.WriteLine("last offset: " + offset.ToString());
			}
			
			File.WriteAllText("./cityCountry.tab", output.ToString());
		}

		static void Main(string[] args)
		{
			GetCityCountry();

		}
	}
}
