#ifndef FILEUTILS_H
#define FILEUTILS_H

#include <base.h>

static char Bf[10*1024];

/////////////////////////////////////////////////
// File-Notifier
class TFileNotifyNoTime: public TNotify{
private:
	TStr FileName;
	PSOut File;
public:
  TFileNotifyNoTime(const TStr& _FileName);
  static PNotify New(const TStr& FileName){return PNotify(new TFileNotifyNoTime(FileName));}

  void OnNotify(const TNotifyType& Type, const TStr& MsgStr);
  void OnStatus(const TStr& MsgStr);
};

class TFileUtils
{
	public:
		
		static TFileNotifyNoTime* FileNotify;		

		static void LogToFile(const TStr& MsgStr) {
			if (FileNotify != NULL) 
				FileNotify->OnStatus(MsgStr);
		}

		static PSIn OpenUnicodeFile(const TStr& FName);
		
		static void LogToFileFmt(const char *FmtStr, ...) {
			if (FileNotify != NULL) {
				va_list valist;
				va_start(valist, FmtStr);
				const int RetVal=vsnprintf(Bf, 10*1024-2, FmtStr, valist);
				va_end(valist);
				if (RetVal!=-1) { LogToFile(Bf); }
			}
		}

		static TStr ReadTextFile(const TStr& FileName, const TStr& DefVal = "");
		static TStr ReadTextFileWithoutComments(const TStr& FileName, const TStr& DefVal = "", const TStr& CommentPrefix = "#");
};

#endif