use strict;

binmode STDIN, ":utf8";
binmode STDOUT, ":utf8";

my $file;
my $line;
my $in;
my $out;

 $in = 'C:\Users\Kaja\Documents\xLike\test_perl_12-04-2013\date_en_test.txt';
 $out = 'C:\Users\Kaja\Documents\xLike\test_perl_12-04-2013\date_en_test_temp3.txt';

open (IN, "$in") || die "Cannot open file [$in]:$!";
open (OUT, ">$out") || die "Cannot open file [$out]:$!";

        while ($line=<IN>) {
            
## --1-- ############################# date-month-year  ##################################

if ($line =~ m/(\b([023]?1(?:st)?|[02]?2(?:nd)?|[02]?3(?:rd)?|(?:[32]0|1[1-3]|[0-2]?[4-9])(?:th)?|first|second|third|fourth|fifth|sixth|seventh|eighth|ninth|tenth|eleventh|twelfth|thirteenth|fourteenth|fifteenth|sixteenth|seventeenth|eighteenth|nineteenth|twentieth|twenty-first|twenty-second|twenty-third|twenty-fourth|twenty-fifth|twenty-sixth|twenty-seventh|twenty-eighth|twenty-ninth|thirtieth|thirty-first)(?:\.|(?:\sof))?\s(january|february|march|april|may|june|july|august|september|october|november|december|(?:jan|feb|mar|apr|may|jun|jul|aug|sep|sept|oct|nov|dec)\.?)\b(?:,?\s((?:[12]\d)?\d\d))\b)/ig) {
    print OUT "<date normalized=\"$2\/$3\/$4\">$1<\\date>\n";
}

## --2-- ############################# date-month ###################################

elsif ($line =~ m/(\b([023]?1(?:st)?|[02]?2(?:nd)?|[02]?3(?:rd)?|(?:[32]0|1[1-3]|[0-2]?[4-9])(?:th)?|first|second|third|fourth|fifth|sixth|seventh|eighth|ninth|tenth|eleventh|twelfth|thirteenth|fourteenth|fifteenth|sixteenth|seventeenth|eighteenth|nineteenth|twentieth|twenty-first|twenty-second|twenty-third|twenty-fourth|twenty-fifth|twenty-sixth|twenty-seventh|twenty-eighth|twenty-ninth|thirtieth|thirty-first)(?:\.|(?:\sof))?\s(january|february|march|april|may|june|july|august|september|october|november|december|(?:jan|feb|mar|apr|may|jun|jul|aug|sep|sept|oct|nov|dec)\.?)\b)/ig) {
    print OUT "<date normalized=\"$2\/$3\/X\">$1<\\date>\n";
}

## --3-- ############################# month-day-year ##############

elsif ($line =~ m/(\b(january|february|march|april|may|june|july|august|september|october|november|december|(?:jan|feb|mar|apr|may|jun|jul|aug|sep|sept|oct|nov|dec)\.?)(?:(?:\sthe\s)|-|\s)\b([023]?1(?:st)?|[02]?2(?:nd)?|[02]?3(?:rd)?|(?:[32]0|1[1-3]|[0-2]?[4-9])(?:th)?|first|second|third|fourth|fifth|sixth|seventh|eighth|ninth|tenth|eleventh|twelfth|thirteenth|fourteenth|fifteenth|sixteenth|seventeenth|eighteenth|nineteenth|twentieth|twenty-first|twenty-second|twenty-third|twenty-fourth|twenty-fifth|twenty-sixth|twenty-seventh|twenty-eighth|twenty-ninth|thirtieth|thirty-first)\b(?:,?\s((?:[12]\d)?\d\d))\b)/ig) {
    print OUT "<date normalized=\"$3\/$2\/$4\">$1<\\date>\n";
}

## --4-- ############################# month-day ##############

elsif ($line =~ m/(\b(january|february|march|april|may|june|july|august|september|october|november|december|(?:jan|feb|mar|apr|may|jun|jul|aug|sep|sept|oct|nov|dec)\.?)(?:(?:\sthe\s)|-|\s)\b([023]?1(?:st)?|[02]?2(?:nd)?|[02]?3(?:rd)?|(?:[32]0|1[1-3]|[0-2]?[4-9])(?:th)?|first|second|third|fourth|fifth|sixth|seventh|eighth|ninth|tenth|eleventh|twelfth|thirteenth|fourteenth|fifteenth|sixteenth|seventeenth|eighteenth|nineteenth|twentieth|twenty-first|twenty-second|twenty-third|twenty-fourth|twenty-fifth|twenty-sixth|twenty-seventh|twenty-eighth|twenty-ninth|thirtieth|thirty-first)\b)/ig) {
    print OUT "<date normalized=\"$3\/$2\/X\">$1<\\date>\n";
}

## --5-- ############################# month-year ##############

elsif ($line =~ m/(\b(january|february|march|april|may|june|july|august|september|october|november|december|(?:jan|feb|mar|apr|may|jun|jul|aug|sep|sept|oct|nov|dec)\.?)(?:,?\s([12]\d\d\d|3[2-9]|[4-9][0-9]))\b)/ig) {
    print OUT "<date normalized=\"X\/$2\/$3\">$1<\\date>\n";
}

## --6-- ############################# DD/MM/YY ##############

elsif ($line =~ m/(\b(1[3-9]|2[0-9]|3[01])(?:\s?[-\/\.]\s?)(0?[1-9]|1[012])(?:(?:\s?[-\/\.]\s?)((?:[12]\d)?\d\d))\b)/ig) {
    print OUT "<date normalized=\"$2\/$3\/$4\">$1<\\date>\n";
}

## --8-- ############################# MM/DD/YY ##############

elsif ($line =~ m/(\b(0?[1-9]|1[012])(?:\s?[-\/\.]\s?)(1[3-9]|2[0-9]|3[01])(?:(?:\s?[-\/\.]\s?)((?:[12]\d)?\d\d))\b)/ig) {
    print OUT "<date normalized=\"$3\/$2\/$4\">$1<\\date>\n";
}

## --7-- ############################# DD/MM ##############

elsif ($line =~ m/(\b(1[3-9]|2[0-9]|3[01])(?:\s?[-\/\.]\s?)(0?[1-9]|1[012])\.?\b)/ig) {
    print OUT "<date normalized=\"$2\/$3\/X\">$1<\\date>\n";
}

## --9-- ############################# MM/DD ##############

elsif ($line =~ m/(\b(0?[1-9]|1[012])(?:\s?[-\/\.]\s?)(1[3-9]|2[0-9]|3[01])\.?\b)/ig) {
    print OUT "<date normalized=\"$3\/$2\/X\">$1<\\date>\n";
}

## --10-- ############################# AMB DD/MM/YY ##############

elsif ($line =~ m/(\b(0?[1-9]|1[012])(?:\s?[-\/\.]\s?)(0?[1-9]|1[012])(?:(?:\s?[-\/\.]\s?)(?:[12]\d)?\d\d?)?\b)/ig) {
    print OUT "<date normalized=\"$2\/$3\/$4\" ambiguity=\"yes\">$1<\\date>\n";
}

## --11-- ############################# AMB DD/MM ##############

elsif ($line =~ m/(\b(0?[1-9]|1[012])(?:\s?[-\/\.]\s?)(0?[1-9]|1[012])\.?\b)/ig) {
    print OUT "<date normalized=\"$2\/$3\/X\" ambiguity=\"yes\">$1<\\date>\n";
}

## --12-- ############################# MM/YYYY ##############

elsif ($line =~ m/(\b(0?[1-9]|1[012])\s?[-\/\.]\s?([12]\d\d\d)\b)/ig) {
    print OUT "<date normalized=\"X\/$2\/$3\">$1<\\date>\n";
}

## --13-- ############################# year only ##############

elsif ($line =~ m/\b([12]\d\d\d)\b/ig) {
    print OUT "<date normalized=\"X\/X\/$1\">$1<\\date>\n";
}

## --14-- ############################# month only ##############

elsif ($line =~ m/\b(January|February|March|April|May|June|July|August|September|October|November|December|(?:Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Sept|Oct|Nov|Dec)\.?)/g) {
    print OUT "<date normalized=\"X\/$1\/X\">$1<\\date>\n";
}

        }
close $in;
close $out;

