#include "base.h"
#include "DateExtractor.h"
#include "FileUtils.h"

int main(int argc, char* argv[])
{	
	/*TStr Text = TStr::LoadTxt(TFileUtils::OpenUnicodeFile("E:\\test.TXT"));
	TStr RegEx = TStr::LoadTxt(TFileUtils::OpenUnicodeFile("E:\\reg.TXT"));
	RegEx.ToTrunc();
	
	RE2::Options ReOptions;
	ReOptions.set_case_sensitive(false);
	ReOptions.set_utf8(false);
	RE2 Re(RegEx.CStr(), ReOptions);

	StringPiece Matches[10];
	const StringPiece SPText(Text.CStr());
	int Off = 0;
	while(Re.Match(SPText, Off, SPText.size(), RE2::UNANCHORED, Matches, 10)) {
		int MatchStart = (int) (Matches[0].begin() - SPText.begin());
		int MatchEnd = (int) (Matches[0].end() - SPText.begin());
		printf("match '%s'\n", Matches[0].ToString().c_str());
		Off = MatchEnd;
	}*/

	/*TStr RegEx = "\\d{2,3}:\\d{2,3}";
		
	RE2::Options ReOptions;
	ReOptions.set_case_sensitive(false);
	ReOptions.set_utf8(false);
	RE2 Re(RegEx.CStr(), ReOptions);

	StringPiece Matches[10];
	const StringPiece SPText("sample text 34:23 asdf");
	int Off = 0;
	while(Re.Match(SPText, Off, SPText.size(), RE2::UNANCHORED, Matches, 10)) {
		int MatchStart = (int) (Matches[0].begin() - SPText.begin());
		int MatchEnd = (int) (Matches[0].end() - SPText.begin());
		printf("match '%s'\n", Matches[0].ToString().c_str());
		Off = MatchEnd;
	}*/
	
	TDateExtractor Extractor;
	//Extractor.NotifyInst = new TStdNotify();
		
	if (argc != 2) {
		printf("choose which language would you like to check (eng, deu, slv, spa, zho)");
		return 0;
	}

	TStr Lang(argv[1]);
	Lang.ToLc();
	TStr Path = "./" + Lang;

	bool Foo;
	TStrV ReDateV, ReDateRangeV;
	TStr LnStr;
	// read date regex list
	TStr FName = "./Regex-date-" + Lang + ".txt";
	if (TFile::Exists(FName)) {
		PSIn FIn = TFIn::New(FName, Foo, true);
		while (FIn->GetNextLn(LnStr)) {
			if (!LnStr.IsWs() && LnStr.Len() > 0 && LnStr.GetCh(0) != '#') {
				LnStr.ToTrunc();		// make sure we remove the possible ending newlines
				ReDateV.Add(LnStr);
			}
		}
		printf("Found %d regular expressions in %s.\nThese are the regexes:\n", ReDateV.Len(), FName.CStr());
		for (int N=0; N < ReDateV.Len(); N++)
			printf("%s\n", ReDateV[N].CStr());
	}
	else
		printf("File %s not found. No regular expressions for date were read.\n", FName.CStr());

	FName = "./Regex-daterange-" + Lang + ".txt";
	if (TFile::Exists(FName)) {
		PSIn FIn = TFIn::New(FName, Foo, true);
		while (FIn->GetNextLn(LnStr)) {
			if (!LnStr.IsWs() && LnStr.Len() > 0 && LnStr.GetCh(0) != '#') {
				LnStr.ToTrunc();		// make sure we remove the possible ending newlines
				ReDateRangeV.Add(LnStr);
			}
		}
		printf("Found %d regular expressions in %s.\nThese are the regexes:\n", ReDateRangeV.Len(), FName.CStr());
		for (int N=0; N < ReDateRangeV.Len(); N++)
			printf("%s\n", ReDateRangeV[N].CStr());
	}
	else
		printf("File %s not found. No regular expressions for date range were read.\n", FName.CStr());

	Extractor.SetRegEx(Lang, ReDateRangeV, ReDateV);

	TStr LogFile = "./Log-DateExtractor-" + Lang + ".txt";
	if (TFile::Exists(LogFile))
		TFile::Del(LogFile);
	Extractor.NotifyInst = new TFileNotifyNoTime(LogFile);
	
	TFFile File(Path, ".txt", false); 
	TUInt64StrPrV FTmFNmV; TStr FNm; 
	TStrV FileV;
	
	TTmStopWatch StopWatch(true);
	while (File.Next(FNm)) {
		//FileV.Add(InXmlFNm);
		TStr Content = TFileUtils::ReadTextFile(FNm);
		TExtractedDateColl Coll;
		Extractor.ExtractDates(Content, Lang, Coll);
	}
	printf("Processing took %d ms", StopWatch.GetMSecInt());
	return 0;
}

