﻿var langList = ["eng", "deu", "spa", "zho", "slv"];
var entityTypes = { "pm_org": true, "pm_location": true, "pm_person": true };
var keywordTypes = { "pm_wiki": true, "pm_keyword": true };

// create html for a single article
function createHtmlForArticle(article, showEventId, articleId) {
    if (!article)
        return "";
    var out = '<div class="row-fluid">\n';
    out += '<div class="span12 article" id=' + articleId + '>\n';
    out += '<a class="pull-left open-gallery" href="#popup-gallery">\n';
    if (article.image_uri)
        out += '<img class="thumbnail media-object" src="' + article.image_uri + '">';
    else
        out += '<img class="thumbnail media-object" src="/img/noimage64.png">';
    out += '</a>';
    var date = Date.parse(article.date + " " + article.time);
        
    out += '<div class="media-body">';
    out += '<span class="rightInfo">';
    out += '<div class="time">' + date.toString('MMM. d, HH:mm') + '</div>';
    out += '<div class="source">' + article.source_title + '</div>';
    //out += '<div class="cossim">Sim to centroid: ' + article.sim + '</div>';
    
    out += '</span>';
    out += '<a href="#popup-gallery" class="open-gallery"><h4 class="media-heading">' + article.title + '</h4></a>';
    out += article.body;
    if (showEventId && article.story_id) {
        out += '<div><a target="_blank" href="/eventViewer?eventId=' + article.story_id + '"><span class="badge">Event id: ' + article.story_id + '</span></a></div>';
    }
    out += '</div>';    // media-body
    out += '</div>';    // span12
    out += '</div>';    // event
    return out;
};


function displayArticle(article) {
    var self = this;
    var uri = article.uri;

    $("#popup-gallery .slide .article-section .content h3.by").html(article.source_title);
    $("#popup-gallery .slide .article-section .content h2").html(article.title);
    $("#popup-gallery .slide .article-section .content .published").html(article.date + " " + article.time);
    $("#popup-gallery .slide .article-section .content div.body").html("");
    $.getJSON("/json/articleJson", { articleUri: uri }, function (articleData) {
        var body = articleData.Body;
        var parBody = "";
        if (articleData.hasImage && articleData.hasImage.length > 0)
            parBody += '<img class="thumbnail media-object" width="200px" height="200px" src="' + articleData.hasImage[0].URI + '" style="float:right; margin-left: 20px; margin-bottom: 20px;">';
        parBody += '<div class="body-text">';
        $.each(body.split("\n"), function (index, par) {
            parBody += "<p>" + par + "</p>";
        });
        parBody += '</div>';
        var entities = "", keywords = "";
        $.each(articleData.hasConcept, function (index, concept) {
            concept.Label = concept.Label.replace("_", " ");
            var dmoz = "";
            if (concept.Label.indexOf("/") >= 0) {
                dmoz = "<br/><b>DMoz category</b>: " + concept.Label;
                concept.Label = concept.Label.substring(concept.Label.lastIndexOf("/") + 1, concept.Label.length);
            }
            var el = '<span class="badge" title="Importance: ' + concept.$fq + dmoz + ', ' + concept.URI + '">' + concept.Label + '</span></a>';
            if (entityTypes[concept.Type] == true)
                entities += el;
            else
                keywords += el;
        });
        parBody += '<div class=""><div class="entities"><strong>Entities: </strong>' + entities + '</div></div>';
        parBody += '<div class=""><div class="entities"><strong>Keywords: </strong>' + keywords + '</div></div>';
        $("#popup-gallery .slide .article-section div.body").html(parBody);
        // udpate tooltips
        $("[data-toggle=tooltip]").tooltip({ "html": true });
    });
    $("#popup-gallery .slide .article-section .content .body").height($("#popup-gallery .slides").height() - 5 - $("#popup-gallery .slides .content h3").height() - $("#popup-gallery .slides .content h2").height() - $("#popup-gallery .slides .content .published").height() - 60);
};

// get the value of an argument from the url
function getURLParameterByName(name) {
    name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
    var regexS = "[\\?&]" + name + "=([^&#]*)";
    var regex = new RegExp(regexS);
    var results = regex.exec(window.location.search);
    if (results == null)
        return "";
    else
        return decodeURIComponent(results[1].replace(/\+/g, " "));
}

function displayStats() {
    $.getJSON("/json/getStatsRecent", function(data) {
        var report = "Number of articles: " + data.articles + "\n";
        report += "Number of concepts (entities + topics): " + data.concepts + "\n";
        report += "Number of new sources: " + data.sources + "\n";
        report += "Number of stories: " + data.stories + "\n";
        alert(report);
    });
}