﻿
var homePage = null;
var map = null;

function Home() {
    this.articles = new Array();
    this.seenUris = {};
    this.sources = new Array();
    this.entities = new Array();
    // the array that we got from json
    this.relatedConcepts = new Array();
    // the x concepts that we are currently showing
    this.displayedConcepts = new Array();

    this.loadHomePage = function () {
        // clear the content
        $("#main .articles-column .articles-container").html("");
        this.loadNextArticleBatch();
        window.setInterval(this.showNextArticle, 3000);
    };

    this.loadNextArticleBatch = function () {
        var self = this;
        var queryArgs = { count: 200 };
        $.getJSON("/json/recentArticles", queryArgs, function (articleData) {
            if (!articleData || articleData.articles == null || !articleData instanceof Array)
                return;
            self.relatedConcepts = articleData.relatedConcepts;
            $.each(articleData.articles, function (index, article) {
                if (self.seenUris[article.uri])
                    return true;
                self.seenUris[article.uri] = true;
                self.articles.push(article);
            });
        });
    };

    this.showNextArticle = function () {
        var self = homePage;
        if (self.articles == null || self.articles.length == 0) {
            self.loadNextArticleBatch();
            return;
        }
        var article = self.articles.shift();
        var output = "";
        output += '<div class="article" id="' + encodeURIComponent(article.uri) + '">\n';
        output += '<div class="holder">\n';
        output += '<div class="frame">\n';
        output += '<div class="title-block">\n';
        output += '<ul class="links">\n';
        output += '<li ><a class="plus"></a></li>\n';
        output += '<li><a class="favorite">favorite</a></li>\n';
        output += '</ul>\n';
        if (article.source_title.length > 36) {
            var tText = article.source_title.substring(0, 36) + '...';
            output += '<h3><a href="#" title="' + article.source_title + '">' + tText + '</a></h3>\n';
        } else {
            output += '<h3><a href="#" title="' + article.source_title + '">' + article.source_title + '</a></h3>\n';
        }
        output += '</div>';
        if (article.image_uri)
            output += '<a href="#popup-gallery" class="open-gallery image-crop"><img src="' + article.image_uri + '" alt="" /></a>\n';
        output += '<h2><a href="#popup-gallery" class="open-gallery">' + article.title + '</a></h2>\n';
        output += '<p>' + article.body + '</p>\n';
        output += '<em class="published">' + article.date + " " + article.time + '</em>\n';
        output += '</div>\n';
        output += '</div>\n';
        output += '</div>\n';
        $("#main .articles-column .articles-container").prepend(output);

        // add some related concept
        if (self.relatedConcepts != null && self.relatedConcepts instanceof Array && self.relatedConcepts.length > 0) {
            var concept = self.relatedConcepts.shift();
            self.displayedConcepts.unshift(concept.label);
            if (self.displayedConcepts.length > 10)
                self.displayedConcepts.pop();
            var concepts = "";
            $.each(self.displayedConcepts, function (index, label) { concepts += '<li><a href="#">' + label + '</a></li>'; });
            $("#entities-tab ul.list").html(concepts);
        }

        // add source
        self.sources.unshift(article.source_title);
        if (self.sources.length > 10)
            self.sources.pop();
        var sources = "";
        $.each(self.sources, function (index, source) { sources += '<li><a href="#">' + source + '</a></li>'; });
        $("#sources-tab ul.list").html(sources);
        
        var latStr = article.source_lat;
        var longStr = article.source_long;
        // Creating a marker and positioning it on the map
        var marker = new google.maps.Marker({
            position: new google.maps.LatLng(parseFloat(latStr), parseFloat(longStr)),
            map: map
        });
    };
};
