/// <reference path="node-vsdoc.js" />
/// <reference path="./node.d.ts" />

// load packages
var util = require("util");
var http = require('http');
var url = require('url');
var querystring = require('querystring');
var SignedRequest = require('facebook-signed-request');

var fs = require('fs');
var path = require('path');

// express middleware
var express = require('express');
//var jQuery = require('jQuery');
var async = require('async');
// mysql
var mysql = require('mysql');

//var toobusy = require('toobusy');		// https://hacks.mozilla.org/2013/01/building-a-node-js-server-that-wont-melt-a-node-js-holiday-season-part-5/

// for amazon set this to a path on S3
//var configurationRootDir = "./configuration"
var configurationRootDir = "./configuration";
var serverPort = 8090;
var ADMIN_ROLE = 2;
var makeAllAdmin = false;

for (var i = 2; i < process.argv.length; i++) {
    var vals = process.argv[i].split(':');
    if (vals.length != 2)
        continue;
    if (vals[0].toLowerCase().indexOf('port') != -1)
        serverPort = parseInt(vals[1]);
    else if (vals[0].toLowerCase().indexOf('configuration') != -1)
        configurationRootDir = vals[1];
}

var sqlDatabase = 'eventregistry';
var sqlUserTable = 'users';
var sqlUser = 'rowboats';
var sqlPass = 'rowboats';
var sqlHost = 'babaji.ijs.si';
//var sqlHost = 'localhost';
var sqlPort = 3306;
SignedRequest.secret = "52cafa2b44c73260e1b62507c1327341";

// server parameters

var userServers = [];
var articleServers = [];
var activityServers = [];

// this will contain header and footer content so that we don't need to read it from disk each time
var header = "", footer = "";

fs.stat(".\\logs", function (err, stats) {
    if (stats == undefined)
        fs.mkdirSync(".\\logs");
});

// initialize the server
var app = express();

app.use(express.cookieParser());
app.use(express.session({ "secret" : "tralala hopsasa" }));	
app.use(express.bodyParser());
app.use(express.methodOverride());

//app.use(express.responseTime());

var isStatusOnline = true;

app.get('/setOnline', function (req, res) { isStatusOnline = true; res.redirect("/"); });
app.get('/setOffline', function (req, res) { isStatusOnline = false; res.redirect("/"); });

//app.use(function(req, res, next) {
//  if (toobusy()) res.send(503, "I'm busy right now, sorry.");
//  else next();
//});


//app.use(function(req, res, next) {
//  if (toobusy()) res.send(503, "I'm busy right now, sorry.");
//  else next();
//});

// handle static files
app.get('/js/*', function (req, res) { staticFile('./static.bootstrap.v3/js/', req.params, 'text/javascript', res) });
app.get('/swf/*', function (req, res) { staticFile('./static.bootstrap.v3/swf/', req.params, 'text/javascript', res) });
app.get('/css/*', function (req, res) { staticFile('./static.bootstrap.v3/css/', req.params, 'text/css', res) });
app.get('/img/*', function (req, res) { staticFile('./static.bootstrap.v3/img/', req.params, 'image/png', res) });
app.get('/fonts/*', function (req, res) { staticFile('./static.bootstrap.v3/fonts/', req.params, 'font/opentype', res) });
app.get('/tests/*', function (req, res) { staticFile('./static.bootstrap.v3/tests/', req.params, 'text/html', res) });
app.get('/favicon.ico', function (req, res) { staticFile('./static.bootstrap.v3/img/', 'favicon.ico', 'image/vnd.microsoft.icon', res) });

// the existing user is trying to log in
app.post('/login', function(req, res) { 
    log('Login attempt');
    loginUser(req.body.email, req.body.pass, req, res,
        function () { log("successful login"); res.write('{"info": "successful login."}'); res.end(); },
        function (errorInfo) { log("unsuccessful login: " + errorInfo); res.write('{"error": "' + (errorInfo ? errorInfo : "failed to login") + '"}'); res.end(); });
});

// the existing user is trying to log in
app.post('/loginFb', function (req, res) {
    log('Login attempt with facebook');
    var reqUrl = url.parse(req.url);
    var args = parseQueryStr(reqUrl.query);
    var redirectUrl = args.redirectUrl;
    log(JSON.stringify(reqUrl));
    var signedRequest = new SignedRequest(req.body.signed_request);
    signedRequest.parse(function (errors, request) {
        if (! request.isValid()) {
            log("unsuccessful login: " + errors);
            res.send('{"error": "failed to login"}');
        } else {
            createUserWithFb(request.data, req, res,
                function () { log("successful login"); res.redirect(redirectUrl); },
                function (errorInfo) { log("unsuccessful login: " + errorInfo); res.send('{"error": "' + (errorInfo ? errorInfo : "failed to login") + '"}'); }
            );
        }
    });
});

//the user wants to log out
app.get('/logout', function(req, res) {
    req.session.user = null;
    res.cookie('fullName', "", { expires: new Date(Date.now() - 100000000) });
    res.cookie('role', "", { expires: new Date(Date.now() - 100000000) });
    res.cookie('fbId', "", { expires: new Date(Date.now() - 100000000) });
	res.redirect('/login'); 
});

app.get('/report', function (req, res) {
    var reqUrl = url.parse(req.url);
    var query = reqUrl.query;
    callArticleProcess("/report", query, req.session, function (data) {
        res.write(data);
        res.end();  // finish server response
    });
});

// the user wants to create a new account
app.post('/register', function(req, res) { 
    log('Register attempt: ' + req.body.email);
    logNode("email="+ req.body.email + ", username=" + req.body.username + ", password=" + req.body.password);
    createUser(req, res,
        function () { res.send('{"info": "successful login."}'); },
        function () { res.send('{"error": "failed to login."}'); });
	
});

app.get('/json/getOverviewTrendingConcepts', function (req, res) {
    var time = process.hrtime();
    var reqUrl = url.parse(req.url);
    var query = reqUrl.query;
    if (!query)
        query = "";
    callArticleProcess("/conceptTrends", "action=getTrends&" + query, req.session, function (trendsStr) {
        var trendsData = JSON.parse(trendsStr)
        var uris = "";
        if (trendsData.error)
            res.send(trendsData);
        else if (trendsData.trends) {
            for (var i = 0; i < trendsData.trends.length; i++)
                uris += "&conceptUri=" + trendsData.trends[i].uri;
            callArticleProcess("/conceptDailyTrends?action=getConceptDailyFreq" + uris, "", req.session, function (conceptDailyFreq) {
                var dailyFreqData = JSON.parse(conceptDailyFreq)
                dailyFreqData.trendsInfo = trendsData;
                res.send(JSON.stringify(dailyFreqData));
                var diff = process.hrtime(time);
                log(util.format("request took %d ms", (diff[0] * 1e9 + diff[1]) / 1e6));
                //res.send(conceptDailyFreq);
            })
        }
        else
            res.send("no valid trends");
    });
});

app.get('/json/*', function (req, res) {
    var time = process.hrtime();
    var reqUrl = url.parse(req.url);
    var query = reqUrl.query;
    log("json request received: " + req.url);
    logNode("json request received: " + req.url);
    var userSqlId = (req.session && req.session.user) ? req.session.user.userSqlId : "";
    var articleMethods = {
        "article": true,
        "concept": true,
        "conceptFolder": true,
        "conceptClass": true,
        "category": true,
        "source": true,
        "story": true,
        "event": true,
        "suggestConcepts": true,
        "suggestConceptClasses": true,
        "suggestSources": true,      
        "suggestSourceLocations": true,
        "suggestLocations": true,
        "conceptTrends": true,
        "conceptDailyTrends": true,
        "eventCompare": true
    };
    
    var methodName = reqUrl.pathname.replace("/json/", "");
    // if the call should be processed using the article process
    if (articleMethods[methodName]) {
        callArticleProcess("/" + methodName, query, req.session, function (data) {
            logNode("method " + methodName + " response: " + data);
            var diff = process.hrtime(time);
            log(util.format("request took %d ms", (diff[0] * 1e9 + diff[1]) / 1e6));
            res.send(data);
        });
    }
    else {
        log("Unknown method call: " + methodName);
        logNode(req.url);
        logNode(req.body);
        res.send("");
    }
});

// ADMIN functionalities
// ALL admin functionalities should be run on all computers (adding, removing, changing folders etc should be run on all instances)
app.get('/jsonAdmin/*', isAdmin, function (req, res) {
    var time = process.hrtime();
    var reqUrl = url.parse(req.url);
    var methodName = reqUrl.pathname.replace("/jsonAdmin/", "");

    var articleMethods = {
        "print": true,
        "suggestConcepts": true,    // updatePrefixes for all servers
        "suggestSources": true,     // updatePrefixes for all servers
        "conceptTrendsAdmin": true,
        "conceptDailyTrendsAdmin": true,
        "conceptFolderAdmin": true,
        "conceptClassAdmin": true,
        "eventAdmin": true,
        "editConcept": true,
        "crossLingStoryLink": true
    };
    
    if (articleMethods[methodName]) {
        callAllArticleProcesses("/" + methodName, url.parse(req.url).query, req.session, function (data) {
            var diff = process.hrtime(time);
            log(util.format("request took %d ms", (diff[0] * 1e9 + diff[1]) / 1e6));
            res.send(data);
        });
    }
    else {
        log("Unknown method call: " + methodName);
        logNode(req.url);
        logNode(req.body);
        res.end();
    }
});

// show the index page for events
app.get('/maintenance', function (req, res) {
    sendTemplate("maintenance", true, req, res);
});

// show the index page for events
app.get('/login', function (req, res) {
    sendTemplate("login", true, req, res);
});

// register a new user
app.get('/register', function (req, res) {
    sendTemplate("register", true, req, res);
});

// show the index page for events
app.get('/searchArticles', isOnline, function (req, res) {
    sendTemplate("searchArticles", true, req, res);
});

app.get('/compareEvents', isOnline, function (req, res) {
    sendTemplate("compareEvents", true, req, res);
});

app.get('/similarEvents', isOnline, function (req, res) {
    sendTemplate("similarEvents", true, req, res);
});

app.get('/eventAdmin', isOnline, isAdmin, function (req, res) {
    sendTemplate("eventAdmin", true, req, res);
});

app.get('/trendingConcepts', isOnline, function (req, res) {
    sendTemplate("trendingConcepts", true, req, res);
});

app.get('/trendingEvents', isOnline, function (req, res) {
    sendTemplate("trendingEvents", true, req, res);
});

app.get('/searchEvents', isOnline, function (req, res) {
    res.redirect('/');
});

app.get('/conceptAdmin', isOnline, isAdmin, function (req, res) {
    sendTemplate("conceptAdmin", false, req, res);
});

app.get('/conceptClassAdmin', isOnline, isAdmin, function (req, res) {
    sendTemplate("conceptClassAdmin", false, req, res);
});

app.get('/mergedStories', isOnline, isAdmin, function (req, res) {
    sendTemplate("mergedStories", true, req, res);
});

app.get('/shouldStoriesMerge', isOnline, function (req, res) {
    sendTemplate("shouldStoriesMerge", true, req, res);
});

app.get('/eventStats', isOnline, isAdmin, function (req, res) {
    sendTemplate("eventStats", true, req, res);
});

app.get('/intro', function (req, res) {
    sendTemplate("intro", true, req, res);
});

// show the index page for events
app.get('/event/:eventId', isOnline, function (req, res) {
    sendTemplate("eventViewer", true, req, res);
});

// show the index page for events
app.get('/storyUri/:storyUri', isOnline, function (req, res) {
    var storyUri = req.params.storyUri;
    callArticleProcess("/event", "action=getEventIdForStory&storyUri=" + encodeURIComponent(storyUri), req.session, function (eventInfoStr) {
        var eventInfo = JSON.parse(eventInfoStr)
        if (eventInfo.eventUri != undefined)
            res.redirect('/event/' + eventInfo.eventUri);
        else
            res.send(eventInfo.error);
    });    
});

// show the index page for events
app.get('/storyId/:storyId', isOnline, function (req, res) {
    var storyId = req.params.storyId;
    callArticleProcess("/event", "action=getEventIdForStory&storyId=" + encodeURIComponent(storyId), req.session, function (eventInfoStr) {
        var eventInfo = JSON.parse(eventInfoStr)
        if (eventInfo.eventUri != undefined)
            res.redirect('/event/' + eventInfo.eventUri);
        else
            res.send(eventInfo.error);
    });
});


// show the index page for events
app.get('/', isOnline, function (req, res) {
    sendTemplate("searchEvents", true, req, res);
});

app.get('/*', isOnline, function (req, res) {
    log("Unknown html request: " + req.url);
    // get appropriate request handler
    res.write("Invalid page request");
    res.end();
});


// prevent ending the node instance in case of an exception
process.on('uncaughtException', function (err) {
    console.log("Unhandled exception: " + err);
});

// load the configuration for the servers. 
// after loading configuration, start the node server
readConfiguration(function () {
    log("listening on port: " + serverPort);
    log("configuration directory: " + configurationRootDir);
    app.listen(serverPort);
});

// refresh the configuration info every X seconds
setTimeout(function reReadConfiguration() {
    readConfiguration();
}, 2 * 60 * 1000);


fs.readFile("./static.bootstrap.v3/parts/header.html", function (err, content) {
    if (err)
        log("Unable to read the header.html");
    else {
        log("loaded the header template");
        header = content;
    }
});

fs.readFile("./static.bootstrap.v3/parts/footer.html", function (err, content) {
    if (err)
        log("Unable to read the footer.html");
    else {
        log("loaded the footer template");
        footer = content;
    }
});

// //////////////////////////////////////////////////////////
// helper functions

function createUser(req, res, callbackOnSuccess, callbackOnFail) {
    var email = req.body.email;
    email = email.toLowerCase();
    var pass = req.body.password;
    log("creating user: " + email);
    
    var client = mysql.createConnection({ host: sqlHost, user: sqlUser, password: sqlPass, port: sqlPort });
    client.query('USE ' + sqlDatabase);

    client.query('SELECT * FROM ' + sqlUserTable + ' WHERE email = ? AND fbId IS NULL', [email],
		function selectCb(err, results, fields) {
		    if (results.length > 0 && results[0].password == pass) {
		        log("This user & pass already exists. Performing a login only");
		        client.end();
		        loginUser(email, pass, req, res, callbackOnSuccess, callbackOnFail);
		    }
		    else if (results.length > 0) {
		        log("User with a given email address already exists.");
		        client.end();
		        res.send('{"error": "User with a given email address already exists."}');
		    }
		    else {
		        log("Creating a new user");
		        // create a new user
		        query = client.query('INSERT INTO ' + sqlUserTable + ' SET email = ?, fullName = ?, password = ?', [email, req.body.fullName, pass],
				    function(err, info) {
				        client.end();
				        loginUser(email, pass, req, res, callbackOnSuccess, callbackOnFail);
				    }
		        );
		    }
		}
	);
}

//// log in the user using the provided email and password
function loginUser(email, password, req, res, callbackOnSuccess, callbackOnFail) {
    log("loging in user " + email);
    email = email.toLowerCase();
    //email = email.toLowerCase();
    var client = mysql.createConnection({ host: sqlHost, user: sqlUser, password: sqlPass, port: sqlPort });
    client.query('USE ' + sqlDatabase);
    client.query('SELECT * FROM ' + sqlUserTable + ' WHERE email = ? AND password = ?', [email, password],
        function selectCb(err, results, fields) {
            if (err) {
                throw err;
            }
            if (results.length != 1) {
                if (callbackOnFail)
                    callbackOnFail("User with specified email and password doesn't exist.", req, res);
            }
            else {
                req.session.user = results[0];
                res.cookie('fullName', results[0].fullName, { expires: new Date(Date.now() + 100 * 24 * 60 * 60 * 1000) });
                res.cookie('role', results[0].role, { expires: new Date(Date.now() + 100 * 24 * 60 * 60 * 1000) });
                if (callbackOnSuccess)
                    callbackOnSuccess(req, res);
            }
            client.end();
        }
    );
}

// create a new fb user (if needed) and then log him in
function createUserWithFb(fbInfo, req, res, callbackOnSuccess, callbackOnFail) {
    var email = fbInfo.registration.email;
    if (email)
        email = email.toLowerCase();
    var name = fbInfo.registration.name;
    var fbId = fbInfo.user_id;
    //email = email.toLowerCase();
    var client = mysql.createConnection({ host: sqlHost, user: sqlUser, password: sqlPass, port: sqlPort });
    client.query('USE ' + sqlDatabase);
    client.query('SELECT * FROM ' + sqlUserTable + ' WHERE fbId = ?', [fbId],
        function selectCb(err, results, fields) {
            if (err) {
                callbackOnFail(err);
                client.end();
                return;
            }
            log("createUserWithFb existing results: " + results.length);
            // new user. first time login with facebook
            if (results.length == 0) {
                query = client.query('INSERT INTO ' + sqlUserTable + ' SET email = ?, fullName = ?, fbId = ?, fbInfo = ?', [email, name, fbId, JSON.stringify(fbInfo)],
                    function (err, info) {
                        if (err) {
                            log(err);
                            throw err;
                        }
                        log("createUserWithFb inserted new user");
                        client.end();
                        loginUserWithFb(fbId, req, res, callbackOnSuccess, callbackOnFail);
                    }
                );
            } else {
                client.end();
                loginUserWithFb(fbId, req, res, callbackOnSuccess, callbackOnFail);
            }
        }
    );
}

// log in a known fb user
function loginUserWithFb(id, req, res, callbackOnSuccess, callbackOnFail) {
    log("loging in fb user " + id);

    //email = email.toLowerCase();
    var client = mysql.createConnection({ host: sqlHost, user: sqlUser, password: sqlPass, port: sqlPort });
    client.query('USE ' + sqlDatabase);
    client.query('SELECT * FROM ' + sqlUserTable + ' WHERE fbId = ?', [id],
        function selectCb(err, results, fields) {
            if (err) {
                throw err;
            }
            // new user. first time login with facebook
            if (results.length > 0) {
                log("loginUserWithFb. Found " + results.length + " matching people");
                log("loginUserWithFb. " + results[0].fullName);
                req.session.user = results[0];
                // clear previous cookies
                //res.clearCookie('fullName');
                //res.clearCookie('role');
                res.cookie('fullName', results[0].fullName, { expires: new Date(Date.now() + 100 * 24 * 60 * 60 * 1000) });
                res.cookie('fbId', results[0].fbId, { expires: new Date(Date.now() + 100 * 24 * 60 * 60 * 1000) });
                res.cookie('role', results[0].role, { expires: new Date(Date.now() + 100 * 24 * 60 * 60 * 1000) });
                callbackOnSuccess();
                client.end();
            }
            else {
                log("loginUserWithFb. No matching people found");
                callbackOnFail();
                client.end();
            }
        }
    );
}


// create options by randomly choosing the user server that should execute the command
function getOptionsForArticle(fullPath) {
    if (articleServers.length == 0) {
        logError("No running article servers were found. unable to execute the command " + fullPath);
        //isStatusOnline = false;
        return null;
    }
    var ind = Math.floor(Math.random() * articleServers.length);
    if (articleServers[ind].failed > 5) {
        articleServers.splice(ind, 1);   // remove this server from the list
        return getOptionsForArticle(fullPath); // compute a new server
    }
    return getOptionsForServer(articleServers[ind], fullPath);
    return {
        host: articleServers[ind].host,
        port: articleServers[ind].port,
        path: fullPath
    };
}

function getOptionsForServer(server, fullPath) {
    return {
        host: server.host,
        port: server.port,
        path: fullPath
    };
}

// reset the failed counter for the specified server
function validateServer(options, serverList) {
    if (serverList == undefined)
        return false;
    serverList.forEach(function (server) {
        if (server.host == options.host && server.port == options.port) {
            server.failed = 0;
            return true;
        }
    });
    return false;
}

function invalidateServer(options, serverList) {
    if (serverList == undefined)
        return false;
    serverList.forEach(function (server) {
        if (server.host == options.host && server.port == options.port) {
            server.failed++;
            return true;
        }
    });
    return false;
}

function makeQueryUrl(path, query, session) {
    var args = parseQueryStr(query);
    // set the userSqlId only if it's not provided in the query. this allows us to do queries for other users
    if (args.userSqlId == undefined && session.user != undefined && session.user.id != undefined) {
        args.userSqlId = session.user.id;
        args.userSqlName = session.user.fullName;
    }
    var url = path + '?'
    for (var key in args) {
        if (args[key] instanceof Array) {
            for (var i = 0; i < args[key].length; i++)
                url += key + "=" + encodeURIComponent(args[key][i]) + '&';
        }
        // convert object to string and url-encode it
        else if (args[key] instanceof Object)
            url += key + '=' + encodeURIComponent(JSON.stringify(args[key])) + '&';
            // url-encode other types of data
        else
            url += key + '=' + encodeURIComponent(args[key]) + '&';
    }
    url = url.substr(0, url.length - 1);		// delete the last &
	return url;
}

// /////////////////////////////////////
//#region Calling single or multiple instances of the services

function callArticleProcess(pathname, query, session, successFunction) {
    var fullPath = makeQueryUrl(pathname, query, session);
    var options = getOptionsForArticle(fullPath);
    if (options == null)
        return;
    logNode("Article call: " + fullPath);

    http.get(options, function (res) {
        var res_all = "";
        // processing QMiner response data
        res.on('data', function (res_chunk) {
            res_all += String(res_chunk);
        });
        res.on('end', function (res_data) {
            logToFile(fullPath, options, "logArticleGet", res_all);
            validateServer(options, articleServers);
            successFunction(res_all);
        });
    }).on('error', function (e) {
        logToFile(fullPath, options, "logArticleGet-err", e.message);
    });
}

//#endregion

// /////////////////////////////////////
//#region call all instances of the same service
function callAllArticleProcesses(pathname, query, session, successFunction) {
    var fullPath = makeQueryUrl(pathname, query, session);
    logNode("All article call: " + fullPath);
    var optionsForAll = articleServers.map(function (server) { return getOptionsForServer(server, fullPath); });

    var processed = false;
    async.forEach(optionsForAll, function (options) {
        http.get(options, function (res) {
            var res_all = "";
            // processing QMiner response data
            res.on('data', function (res_chunk) {
                res_all += String(res_chunk);
            });
            res.on('end', function (res_data) {
                if (processed == false) {
                    successFunction(res_all);
                    processed = true;           // make sure we don't call successFunction several times
                    logToFile(fullPath, options, "logArticleDo", res_all);
                }
                var validated = validateServer(options, articleServers);
                //if (validated)
                //    isStatusOnline = true;

            });
        }).on('error', function (e) {
            invalidateServer(options, articleServers);
            logToFile(fullPath, options, "logArticleDo-err", e.message);
        });
    },
    function (err) { });
}

//#endregion

//////////////////////////////////////////////////
//#region logging functions
function logError(text) {
    var t = new Date();
    var timeStr = t.getFullYear() + "-" + (t.getMonth() + 1) + "-" + t.getDate() + " " + t.getHours() + ":" + t.getMinutes();
    console.log(timeStr + " " + text);
    fs.appendFile(".\\logs\\logError.txt", timeStr + " " + text + "\n");
}

function log(text) {
    var t = new Date();
    var timeStr = t.getFullYear() + "-" + (t.getMonth() + 1) + "-" + t.getDate() + " " + t.getHours() + ":" + t.getMinutes();
    console.log(timeStr + " " + text);
    fs.appendFile(".\\logs\\log.txt", timeStr + " " + text + "\n");
}

function logToFile(query, options, filename, text) {
    var t = new Date();
    var timeStr = t.getFullYear() + "-" + (t.getMonth() + 1) + "-" + t.getDate() + " " + t.getHours() + ":" + t.getMinutes();
    fs.appendFile(".\\logs\\" + filename + ".txt", timeStr + " " + options.host + ":" + options.port + query + "\n" + text + "\n");
    //console.log(timeStr + query + "\n" + text);
}

function logNode(text) { 
    var t = new Date();
    var timeStr = t.getFullYear() + "-" + (t.getMonth() + 1) + "-" + t.getDate() + " " + t.getHours() + ":" + t.getMinutes();   
    fs.appendFile(".\\logs\\logNode.txt", timeStr + " " + text + "\n");
}

//function logUser(query, options, text) {
//    var t = new Date();
//    var timeStr = t.getFullYear() + "-" + (t.getMonth() + 1) + "-" + t.getDate() + " " + t.getHours() + ":" + t.getMinutes();
//    console.log(timeStr + " " + text);

//    // use {'flags': 'a'} to append and {'flags': 'w'} to erase and write a new file
//    var logFile = fs.createWriteStream('logUser.txt', { 'flags': 'a' });
//    logFile.write(timeStr + " " + options.host + ":" + options.port + query + "\n" + text + "\n");
//}

//function logRecent(query, options, text) {
//    var t = new Date();
//    var timeStr = t.getFullYear() + "-" + (t.getMonth() + 1) + "-" + t.getDate() + " " + t.getHours() + ":" + t.getMinutes();
//    //console.log(timeStr + " " + text);

//    // use {'flags': 'a'} to append and {'flags': 'w'} to erase and write a new file
//    var logFile = fs.createWriteStream('logRecent.txt', { 'flags': 'a' });
//    logFile.write(timeStr + " " + options.host + ":" + options.port + query + "\n" + text + "\n");
//}

//function logActivity(query, options, text) {
//    var t = new Date();
//    var timeStr = t.getFullYear() + "-" + (t.getMonth() + 1) + "-" + t.getDate() + " " + t.getHours() + ":" + t.getMinutes();
//    //console.log(timeStr + " " + text);

//    // use {'flags': 'a'} to append and {'flags': 'w'} to erase and write a new file
//    var logFile = fs.createWriteStream('logActivity.txt', { 'flags': 'a' });
//    logFile.write(timeStr + " " + options.host + ":" + options.port + query + "\n" + text + "\n");
//}

//#endregion

//////////////////////////////////////////////////
//#region helper functions

// checks if the user is logged in. if not, it redirects him to the login page
function isAuth(req, res, next) {
    return next();
    //console.log("Checking authentication...")
    //if (req.params == 'login') { return next(); }
    //if (req.session.user != null) { 
    //    //log('User: ' + req.session.user.username); 
    //    return next(); 
    //}
    //res.redirect('/login');
}

function isOnline(req, res, next) {
    if (!isStatusOnline)
        res.redirect("/maintenance");
    else
        next();
}

// for some functionality the user has to be admin otherwise he is not allowed to perform some activities
function isAdmin(req, res, next) {
    if (makeAllAdmin) return next();
    //log("Checking admin authentication...")
    if (req.params == 'login') { return next(); }
    //if (req.session.user != null && req.session.user.isAdmin == true) { 
    if (req.session.user != null && req.session.user.role == ADMIN_ROLE) {
        log('User has admin privileges: ' + req.session.user.fullName);
        return next();
    }
    else {
        log("User doesn't have admin privileges. redirecting to login screen...");
        res.redirect('/login');
    }
}

// error responses for file-not-fount
function errorNotFound(err, res) {
    log('Error[404]: ' + err);
    res.statusCode = 404; res.end();
}

// return static file
function staticFile(filePath, fileName, mimeType, res) {
    //console.log('Filename: ' + fileName);
    res.setHeader('Content-Type', mimeType);
    fs.readFile(filePath + fileName, function (err, data) {
        // if error, return error
        if (err) { errorNotFound(err, res); return; }
        // else return the file
        res.send(data);
    });
}

function sendTemplate(templateName, addHeaderFooter, req, res) {
    var filePath = "./static.bootstrap.v3/";
    console.log('Template: ' + filePath + templateName);
    if (req.session && req.session.user) {
        res.cookie('fullName', req.session.user.fullName);
        res.cookie('role', req.session.user.role);
        if (req.session.user.fbId)
            res.cookie('fbId', req.session.user.fbId);
    }

    var templateFileName = filePath + templateName + '.html';
    fs.readFile(templateFileName, 'utf-8', function (err, data) {
        if (err)
            errorNotFound(err, res);
        else {
            if (addHeaderFooter)
                res.send(header + data + footer);
            else
                res.send(data);
        }
    });
}


// parse arguments from the url query. if query is already a dict then just return it. if null then create an empty dict
function parseQueryStr(query) {
    if (typeof query == "string")
        return querystring.parse(query);
    else if (typeof query == "object" && query != null)
        return query;
    else
        return {};
}

// add the startsWith function to the string class
//if (typeof String.prototype.startsWith != 'function') {
//    String.prototype.startsWith = function (str) {
//        return this.indexOf(str) == 0;
//    };
//}

function pause(millis) {
    var date = new Date();
    var curDate = null;

    do { curDate = new Date(); }
    while (curDate - date < millis);
}

// ///////////////////////////////////////////
// configuration functions
function getHostName(compAddr) {
    if (compAddr.lastIndexOf('\\') != -1)
        compAddr = compAddr.substring(compAddr.lastIndexOf('\\') + 1);
    if (compAddr.lastIndexOf('/') != -1)
        compAddr = compAddr.substring(compAddr.lastIndexOf('\\') + 1);
    var sepPos = compAddr.indexOf("#");
    if (sepPos == -1) {
        console.log("Invalid computer address. Separator # was not found in the computer address " + compAddr);
        return "";
    }
    return compAddr.substring(0, sepPos);
}

function getPort(compAddr) {
    var sepPos = compAddr.lastIndexOf('#');
    if (sepPos == -1) {
        console.log("Invalid computer address. Separator # was not found in the computer address " + compAddr);
        return 80;
    }
    return compAddr.substring(sepPos+1);
}

// read the configuration settings about the running user, recent and activity servers
function readConfiguration(callback) {
    log("reading server configurations...");
    var userDir = path.join(configurationRootDir, "users");
    var articleDir = path.join(configurationRootDir, "articles");
    var activityDir = path.join(configurationRootDir, "activity");

    var finishedCount = 0;
    // read the user servers
    fs.exists(userDir, function (exists) {
        fs.readdir(userDir, function (err, files) {
            var list = [];
            if (files != undefined)
                files.forEach(function (file) {
                    list.push({ 'host': getHostName(file), 'port': getPort(file), 'failed': 0 });
                    log("users server: " + getHostName(file) + ":" + getPort(file));
                });
            userServers = list;
            finishedCount += 1;
            if (finishedCount == 3 && callback != null)
                callback();
        });
    });
    // read the article servers
    fs.exists(articleDir, function (exists) {
        fs.readdir(articleDir, function (err, files) {
            var list = [];
            if (files != undefined)
                files.forEach(function (file) {
                    list.push({ 'host': getHostName(file), 'port': getPort(file), 'failed': 0 });
                    log("articles server: " + getHostName(file) + ":" + getPort(file));
                });
            articleServers = list;
            finishedCount += 1;
            if (finishedCount == 3 && callback != null)
                callback();
        });
    });
    // read the activity servers
    fs.exists(activityDir, function (exists) {
        fs.readdir(activityDir, function (err, files) {
            var list = [];
            if (files != undefined)
                files.forEach(function (file) {
                    list.push({ 'host': getHostName(file), 'port': getPort(file), 'failed': 0 });
                    log("activity server: " + getHostName(file) + ":" + getPort(file));
                });
            activityServers = list;
            finishedCount += 1;
            if (finishedCount == 3 && callback != null)
                callback();
        });
    });
}
