﻿// create a dummy element, apply the appropriate classes,
// and then measure the element
//var measuredWidths = {};


//function measureTextWidth(text, classname, extraSize) {
//    if (extraSize == undefined)
//        extraSize = 0;
//    if (!text || text.length === 0) return 0;
//    if (measuredWidths[text + "-" + classname])
//        return measuredWidths[text + "-" + classname] + extraSize;
//    var container = d3.select('body').append('svg');
//    container.append('text')
//        .attr({ x: -1000, y: -1000 })
//        .attr('class', classname)
//        .text(text);
//    var bbox = container.node().getBBox();
//    container.remove();
//    measuredWidths[text + "-" + classname] = bbox.width;
//    return bbox.width + extraSize;
//};

//var measuredHeights = {};

//function measureTextHeight(text, classname, extraSize) {
//    if (extraSize == undefined)
//        extraSize = 0;
//    if (!text || text.length === 0) return 0;
//    if (measuredHeights[text + "-" + classname])
//        return measuredHeights[text + "-" + classname] + extraSize;
//    var container = d3.select('body').append('svg').attr('class', classname);
//    container.append('text').attr({ x: -1000, y: -1000 }).text(text);
//    var bbox = container.node().getBBox();
//    container.remove();
//    measuredHeights[text + "-" + classname] = bbox.height;
//    return bbox.height + extraSize;
//};

function showConceptGraph(data) {
    var w = $("#concept-graph").width() - 5;
    var h = $("#concept-graph").height() - 5;
    var entityData = data;

    var weiArg = 0, disArg1 = 1, disArg2 = 10, sizeArgT = 4, sizeArgE = 4, sizeArg = 4, relaArg = 0;
    var entityUriToIndex = {};
    for (var i = 0; i < entityData.concepts.length; i++) {
        entityUriToIndex[parseInt(entityData.concepts[i].id)] = i;
        //entityData.concepts.x = cx(width / 2 + 200 * (Math.random() - 0.5), true);
        //entityData.concepts.x = cy(height / 2 + 200 * (Math.random() - 0.5), true);
    }

    // shorten the list of links
    entityData.links = entityData.links.slice(0, 35);

    for (var i = 0; i < entityData.links.length; i++) {
        entityData.links[i].source = entityUriToIndex[entityData.links[i].id1];
        entityData.links[i].target = entityUriToIndex[entityData.links[i].id2];
    }

    var maxLink = 0, minLink = 0;
    var maxNode = 0, minNode = 0;
    var nodes, links, svg, nodeCircles, nodeRects, nodeTexts;
    
    var force;
    var width = w, height = h;

    var max = 0, min = 5;
    var log = d3.scale.log();
    var marginX = 50, marginY = 10;
    
    maxLink = d3.max(entityData.links, function (i) { return i.score; });
    minLink = d3.min(entityData.links, function (i) { return i.score; });
    maxNode = d3.max(entityData.concepts, function (i) { return i.score; });
    minNode = d3.min(entityData.concepts, function (i) { return i.score; });

    force = d3.layout.force()
        .gravity(0.05)
        .charge(-150)
        .friction(0.8)
        .linkDistance(function (d) {
            return 200 - 100 * (d.score / maxLink);
        })
        .linkStrength(0.3)
        .size([w, h])
        .nodes(entityData.concepts)
        .links(entityData.links)
        .start();
    
    entityData.concepts.forEach(function (d, i) {
        d.x = cx(width / 2 + 200 * (Math.random() - 0.5), true);
        d.y = cy(height / 2 + 200 * (Math.random() - 0.5), true);
        d.px = d.x;
        d.py = d.y;
    });
    
    // remember the cleaned data in case we call the redrawTimeline()
    d3.select("#concept-graph svg").remove();

    svg = d3.select("#concept-graph")
        .append("svg")
        .attr("width", w)
        .attr("height", h);
    
    links = svg.selectAll("line.link")
        .data(entityData.links)
        .enter()
        .append("line")
        .attr("class", "link");
    
    nodes = svg.selectAll(".node")
        .data(entityData.concepts)
        .enter()
        .append("g")
        .attr("class", "node")
        .call(force.drag);

    nodeRects = nodes.append("rect");
    //nodeCircles = node.append("circle");
    nodeTexts = nodes.append("text");

    initLinks();
    initNodes();

    nodes.on("mouseover", function (d, i) {
        //$("#dialog").setAttribute("title",nodesArray[i].uri);
        //d3.select(this).select("rect").style("fill", "orangered").style("stroke", "black");
        //d3.select(this).select("text").style("fill", "#FFF");
        d3.select(this).attr("class", "selected-node");
        links[0].forEach(function(l, i) {
            if (l.__data__.source == d || l.__data__.target == d) {
                d3.select(l).style("stroke-opacity", null);
                d3.select(l).style("stroke", null);
            }
        });
        links.attr("class", function (l) {
            if (l.source == d || l.target == d) {
                return "selected-link";
            }
            else
                return "link";
        });
    });
    nodes.on("mouseout", function () {
        initLinks();
        initNodes();
    });
    
    force.on("tick", function () {
        links.attr("x1", function(d) { return cx(d.source.x, 1); })
            .attr("y1", function (d) { return cy(d.source.y, 1); })
            .attr("x2", function (d) { return cx(d.target.x, 1); })
            .attr("y2", function (d) { return cy(d.target.y, 1); });

        nodes.attr("transform", function (d) {
            return "translate(" + cx(d.x, d.visible) + "," + cy(d.y, d.visible) + ")";
        });
    });
    
    function initLinks() {
        links
            //.style("stroke-width", function (d) { return 10 / cdis(d.value); })
            .attr("class", "link")
            .style("stroke-opacity", function (l) {
                //if (l.source.weight > weiArg && l.target.weight > weiArg) {
                //    return 0.3;
                //} else
                //    return 0;
                return 0.1 + 0.4 * ((l.score - minLink) / (maxLink - minLink));
            });
    }
    
    function initNodes() {
        nodeRects
            .attr("class", "text-bg")
            .attr("x", function(d) { return -measureTextWidth(d.label, "text.node", 5) / 2; })
            .attr("y", function (d) { return -measureTextHeight(d.label, "text.node") / 2; })
            .attr("width", function (d) { return measureTextWidth(d.label, "text.node", 5); })
            .attr("height", function (d) { return measureTextHeight(d.label, "text.node"); })
            .attr("rx", function(d) { return 8; })
            .attr("ry", function(d) { return 8; });

        //nodeCircles
        //    .attr("r", function(d) { return 3 + 5 * ((d.score - minNode) / (maxNode - minNode)); })
        //    .attr("class", function(d) { return d.type; });

        nodeTexts
            .attr("dy", ".3em").style("text-anchor", "middle")
            .attr("class", function(d) { return d.type; })
            .style("font-size", function(d) { return (12 + 10 * (d.score / maxNode)) + "px"; })
            .text(function (d) { return d.label; });
    }
    
    function cdis(dis) {
        // var dis = 3 - disArg1 * log(dis) / log(disArg2);
        var dis = min - disArg1 * log(dis) / log(disArg2);
        // alert(dis);
        return dis;
    }
    function cx(dx, visible) {
        if (visible == 0)
            return -1000;
        return Math.max(marginX, Math.min(w-marginX, dx));
    }
    function cy(dy, visible) {
        if (visible == 0)
            return -1000;
        return Math.max(marginY, Math.min(h - marginY, dy));
    }
    
    function setArgs(wei, rela, size, dis2, dis) {
        sizeArg = size;
        sizerefresh();
        disArg1 = dis;
        disArg2 = dis2;
        disrefresh();
        weiArg = wei;
        refresh();
        relaArg = rela / 100;
        refresh();
    }
    function setdistance1(arg) {
        disArg1 = arg;
        disrefresh();
    }
    function setdistance2(arg) {
        disArg2 = arg;
        disrefresh();
    }
    function setsize(arg) {
        sizeArg = arg;
        sizerefresh();
    }
    function setweight(arg) {
        weiArg = arg;
        refresh();
    }
    function setrelation(arg) {
        relaArg = arg;
        refresh();
    }
    function sizerefresh() {
        nh = nh0 * sizeArg;
        nw = nw0 * sizeArg;
        initNodes();
    }
    function disrefresh() {
        max = 0, max2 = 0;
        for (var i in linkdatas) {
            max = max > cdis(linkdatas[i].value) ? max : cdis(linkdatas[i].value);
        }
        refresh();
        force.linkDistance(function (d) {
            max2 = max2 > ((cdis(d.value) / max) * (w / 2)) ? max2 : ((cdis(d.value) / max) * (w / 2));
            return ((cdis(d.value) / max) * (w / 2));
        });
    }
    //function refresh() {
    //    linkdatas.forEach(function (d, i) {
    //        if (d.value < relaArg) {
    //            if (d.source != nullnode && d.target != nullnode) {
    //                d.source = nullnode2;
    //                d.target = nullnode2;
    //            }
    //        } else {
    //            if (d.source == nullnode2 && d.source != nullnode && d.target != nullnode) {
    //                linkdatas[i] = clone(linkdatas0[i]);
    //            }
    //        }
    //    });
    //    var cklist = $("#topiclist :checkbox");
    //    cklist.each(function () {
    //        if (!this.checked) {
    //            removeTopic(this.id);
    //        }
    //    });

    //    force.nodes(nodedatas).links(linkdatas).start();
    //    svg.selectAll("line.link").data(linkdatas).enter();
    //    initLinks();
    //    nodedatas.forEach(function (d) {
    //        d.visible = d.weight > weiArg ? 1 : 0;
    //    });
        
    //    force.on("tick", function () {
    //        link.attr("x1", function (d) {
    //            return cx(d.source.x, d.source.visible);
    //        }).attr("y1", function (d) {
    //            return cy(d.source.y, d.source.visible);
    //        }).attr("x2", function (d) {
    //            return cx(d.target.x, d.target.visible);
    //        }).attr("y2", function (d) {
    //            return cy(d.target.y, d.target.visible);
    //        });

    //        nodes.attr("transform", function (d) {
    //            return "translate(" + cx(d.x, d.visible) + "," + cy(d.y, d.visible) + ")";
    //        });
    //    });

    //}

}
