

$().ready(function () {
    var eventId = decodeURIComponent(getURLParameterByName("eventId"));
    similarEvents.getSimilarEvents(eventId);
});

function SimilarEvents() {

    this.getSimilarEvents = function (eventId) {
        var self = this;    
        
        showWait();
        var args = "eventId=" + eventId;
        $.getJSON("/json/event?action=getSimilarEvents&includeSimBetweenAllEvents=1&" + args, function (eventData) {
            hideWait();
            if (eventData.error) {
                $("#result-area").css("display", "none");
                $("#error-container").css("display", "block");
                $("#error-text").html(eventData.error);
                return;
            } 
            $("#error-container").css("display", "none");
            var resultArea = $("#result-area");
            resultArea.css("display", "block");

            var out = "<h3>{0}</h3>\n".format(eventData.eventInfo.primaryStory.medoidArticle.title);
            out += "<p>Similar events:</p>\n";
            $.each(eventData.similarEvents, function(i, event) {
                out += '<p><strong class="text-success">{0} %</strong> <a href="/similarEvents?eventId={1}">{2}</a> ({3} articles) </p>\n'.format(100*event.sim, event.id, event.primaryStory.medoidArticle.title, event.primaryStory.articleCount);
            });
            resultArea.html(out);
        });
    };

};

similarEvents = new SimilarEvents();