
eventRegApp.controller("OverviewConceptTrendsCtrl", function ($scope, $http, $browser, $location, langOptions, utils) {
    $scope.utils = utils;
    $scope.langOptions = langOptions;
    $scope.conceptTrends = new ConceptTrendsGraph({ containerNm: "#concept-trends", tagInputNm: "#trending-concepts-taginput", offsetType: "silhouette" });
    $scope.ignoreOnAdd = false;
    $scope.dayOffset = 0;
    $scope.initialized = false;

    $scope.loadTrendingConcepts = function (showWait) {
        var types = "";
        $.each($(".entity-types label.checked"), function (i, item) {
            types += "&conceptType=" + $(item).attr("for");
        });
        showWait && $scope.utils.showWait("#trending-concept-container .content", "#trending-concept-container .wait-container")
        var testOff = "D" + Math.abs($scope.dayOffset) + ",D" + Math.abs($scope.dayOffset) + 1;
        $http.get("/json/getOverviewTrendingConcepts?count=10&nullPopOffs=M0,M1&testPopOffs=" + testOff + types)
            .success(function (data, status, headers, config) {
                $scope.initialized = true;
                $scope.utils.hideWait("#trending-concept-container .content", "#trending-concept-container .wait-container");
                $scope.ignoreOnAdd = true;
                $scope.conceptTrends.setConceptTrends(data);
                $scope.conceptTrends.displayConceptTrends();
                $scope.ignoreOnAdd = false;
            });
    }

    $scope.onAddTrendingConcept = function (concepts) {
        if ($scope.ignoreOnAdd || concepts.length == 0)
            return;
        var conceptUri = $(concepts[0]).data("options").uri;
        $.getJSON("/json/conceptDailyTrends?action=getConceptDailyFreq&conceptUri=" + encodeURIComponent(conceptUri), function (data) {
            $scope.conceptTrends.addConcepts(data);
        });
    }

    $().ready(function () {
        // build the tags input box for entering concepts, ...
        $('#trending-concepts-taginput').tagsInput({
            defaultText: "What topics are you interested in?", minInputWidth: 140,
            "onRemoveTag": function (concept) { $scope.conceptTrends.onRemoveTag(concept); },
            "onAddTag": function (concept) { $scope.onAddTrendingConcept(concept); }
        });
        
        $("#trending-concepts-taginput_tag").autocomplete({
            source: function (request, response) {
                var query = "/json/suggestConcepts?prefix=" + request.term + "&lang=" + $scope.langOptions.lang.val;
                $.getJSON(query, function (suggList) { response(suggList); });
            },

            select: function (event, ui) {
                $('#trending-concepts-taginput').addTag(ui.item.label, { focus: true, type: ui.item.type, id: ui.item.id, uri: ui.item.uri, label: ui.item.label, classes: [ui.item.type, "concept"] });
                return false;
            }
        }).data("uiAutocomplete")._renderItem = renderConceptItem;

        $scope.loadTrendingConcepts(true);

        // changing the time of interest
        var updateTimer;
        $scope.$watch("dayOffset", function () {
            updateTimer = setTimeout(function () {
                $scope.loadTrendingConcepts(false);
                clearTimeout(updateTimer);
            }, 200);
        })

        // changing the checkboxes for concepts
        var cbUpdateTimer;
        // refresh the entity graph if update button is clicked
        $(".entity-types .checkbox").click(function () {
            setupLabel();   // hack: cb and radioboxes don't get updated if inside accordions or tabs (using angular ui)
            clearTimeout(cbUpdateTimer);
            cbUpdateTimer = setTimeout(function () {
                $scope.loadTrendingConcepts();
                clearTimeout(cbUpdateTimer);
            }, 1000);
        });

    });
});