
//$().ready(function () {
//    try {
//        $('#navbar-trends').addClass("active");
//    } catch (e) { }
//    $("#lang-combo").change(function() {
//        updateUrlFromForm();
//        overview.showTrendingEvents();
//    });
//    updateFormFromUrl();
//    overview.showTrendingEvents();
//});

eventRegApp.controller("TrendingEventsCtrl", function ($scope, $http, langOptions, utils) {
    $scope.utils = utils;
    $scope.langOptions = langOptions;
    
    $scope.trendingEvents = [];
    $scope.trendsGraph = new ArticleTrendsGraph({ containerNm: "#trends-container", defaultZoomEnabled: false });

    $scope.showTrendingEvents = function () {
        $http.get("/json/event?action=getTrendingEvents&minSim=0.8&count=5&lang=" + $scope.langOptions.lang.val)
            .success(function (trendData, status, headers, config) {
                $scope.trendingEvents = trendData.trendingEvents;
                $scope.error = trendData.error;
                
                var articlesList = $.map($scope.trendingEvents, function (event) { return [event.articles]; });       // we need to double-array it otherwise it just creates one array - jquery pecularity
                var legend = $.map($scope.trendingEvents, function (event) { return $scope.getMultiLingInfoForLang(event.eventDetails).title; });

                // we need to uncloak first, otherwise the width is too big
                setTimeout(function () {
                    $("#trends-container").css("display", "block");
                    $scope.trendsGraph.drawArticleTrends(articlesList, legend, 400);
                }, 100);
            });
    };
    
    // helper methods
    $scope.getMultiLingInfoForLang = function(event) {
        var eventInfo = event.multiLingInfo[$scope.langOptions.lang.val];
        if (eventInfo)
            return eventInfo;
        if (event.multiLingInfo["eng"])
            return event.multiLingInfo["eng"];
        if (Object.keys(event.multiLingInfo).length > 0)
            return event.multiLingInfo[Object.keys(event.multiLingInfo)[0]];
    }
    
    $scope.getEventLocation = function (event) {
        if (!event.location)
            return "";
        var lang = $scope.langOptions.lang.val;
        lang = lang.charAt(0).toUpperCase() + lang.slice(1); // capitalize first letter
        var locStr = "";
        locStr = event.location["label" + lang];
        if (event.location.country)
            locStr += ", " + event.location.country["label" + lang];
        return locStr;
    };

    
    $(document).ready(function () {
        try { updateHeader(); } catch (e) { }
        $scope.showTrendingEvents();
    });
})
