#ifndef CLUSTEREVALUATION_H
#define CLUSTEREVALUATION_H

#include <base.h>
#include "../NewsMiner/NewsBase.h"

class TAcc
{
private:
	PMom PrecMom;
	PMom RecMom;
	PMom F1Mom;

public: 
	TAcc();
	void Add(const double& Prec, const double& Rec, const double& Wgt = 1.0);
	void Init();
	
	void Def() { PrecMom->Def(); RecMom->Def(); F1Mom->Def(); }
	
	double GetPrec() const { return PrecMom->GetMean(); }
	double GetPrecStDev() const { return PrecMom->GetSDev(); }
	double GetRec() const { return RecMom->GetMean(); }
	double GetRecStDev() const { return RecMom->GetSDev(); }
	double GetF1() const { return F1Mom->GetMean(); }
	double GetF1StDev() const { return F1Mom->GetSDev(); }

	PJsonVal GetJson() const;
};

class TClusterEvaluation;
typedef TPt<TClusterEvaluation> PClusterEvaluation;

class TClusterEvaluation {
public:
	friend class TPt<TClusterEvaluation>;
private:
	TCRef CRef;
	PNewsBase NewsBase;

	TAcc TotalAcc;
	THash<TStr, TAcc> DailyAccH;

	TClusterEvaluation(const PNewsBase& _NewsBase) : NewsBase(_NewsBase) { }

public: 
	static PClusterEvaluation New(const PNewsBase& _NewsBase) {
		return new TClusterEvaluation(_NewsBase);
	}

	void RunEvaluation();
	const TAcc& GetTotalAcc() { return TotalAcc; }
	
	void GetDailyAccKeys(TStrV& AccKeyV) const { AccKeyV.Clr(); DailyAccH.GetKeyV(AccKeyV); }
	const TAcc& GetDailyAcc(const TStr& Key) { return DailyAccH.GetDat(Key); }
	
};

#endif