#ifndef _CONCEPTLABEL_H
#define _CONCEPTLABEL_H

#include <base.h>

class TConceptLabel;
typedef TPt<TConceptLabel> PConceptLabel;


class TConceptLabel
{
private:
	TCRef CRef;
private:
	friend class TPt<TConceptLabel>;

	TStr DbsPath;
	bool LabelsChanged;
	THash<TStr, THash<TStr, TStr> > ConceptUriToLangValH;	// Concept uri -> (Lang->Label)
	TStrV FallbackLangV;
	
	TConceptLabel(const TStr& DbsPath);

public:
	static PConceptLabel New(const TStr& FName) { return new TConceptLabel(FName); }
	~TConceptLabel();

	void Load();
	void Save() const;

	bool HasConcept(const TStr& ConceptUri) const;
	// do we have label in the desired language
	bool HasConceptLabel(const TStr& ConceptUri, const TStr& Lang) const;
	// set concept label for the selected language
	void SetConceptLabel(const TStr& ConceptUri, const TStr& Lang, const TStr& Label);
	// get concept label in desired language
	TStr GetConceptLabel(const TStr& ConceptUri, const TStr& Lang);

	const THash<TStr, TStr> GetConceptLabels(const TStr& ConceptUri) const;

	void RemoveConcept(const TStr& ConceptUri);

private:
	void LoadFromJson();
	void SaveToJson() const;

};


#endif