#ifndef NEWSACTIVITY_H
#define NEWSACTIVITY_H

#include <base.h>
#include <qminer.h>

class TActivityItem
{
private:
	TUInt64 ItemId;
	TUInt64 ActivityId;
	TTm Tm;

public:
	TActivityItem(const uint64& _ItemId, const uint64& _ActivityId, const TTm& _Tm) : ItemId(_ItemId), ActivityId(_ActivityId), Tm(_Tm) { };
	explicit TActivityItem(TSIn& SIn);
	void Save(TSOut& SOut) const;
	TUInt64 GetItemId() const { return ItemId; }
	TUInt64 GetActivityId() const { return ActivityId; }
	TTm GetTm() const { return Tm; }
};

class TNewsActivity;
typedef TPt<TNewsActivity> PNewsActivity;
class TNewsActivity {
public:
	friend class TPt <TNewsActivity>;

private:
	TCRef CRef;

	TStr FName;
	TUInt64 LastArticleActivityId;
	TUInt64 LastStoryActivityId;

	TStr SettingsFileName;
	int ArticleCount;
	int StoryCount;

	TNewsActivity(const TStr& FName, const TStr& SettingsFileName);
	~TNewsActivity();

public:
	TLst<TActivityItem> ArticleActivityL;
	TLst<TActivityItem> StoryActivityL;

	static PNewsActivity New(const TStr& FName, const TStr& SettingsFileName) {
		return new TNewsActivity(FName, SettingsFileName);
	}

	bool Load();
	void Save();

	void AddArticleActivity(const uint64& ArticleId, const TTm Tm = TTm::GetCurLocTm());
	void AddStoryActivity(const uint64& StoryId, const TTm Tm = TTm::GetCurLocTm());

	int GetArticleCount() { return ArticleActivityL.Len(); }
	int GetEventCount() { return ArticleActivityL.Len(); }

	//const TLst<TActivityItem> GetArticleActivity() const { return ArticleActivityL; }
	//const TLst<TActivityItem> GetStoryActivity() const { return StoryActivityL; }
};


#endif