#include "../NewsMiner/news.h"
#include "ActivityBase.h"
//#include "SimpleFolderStore.h"
#include <qminer_srv.h>
#include "../NewsMiner/NewsConst.h"

///////////////////////////////////////////////
// PlusMachines-Server-Helper-Utilities
ClassTP(TNewsSrvUtil, PNewsSrvUtil)//{
	PNewsBase NewsBase;

	// user base
	PActivityBase ActivityBase;

public:
	TNewsSrvUtil(const PNewsBase& _NewsBase, const PActivityBase& _ActivityBase);
	static PNewsSrvUtil New(const PNewsBase& NewsBase, const PActivityBase& ActivityBase) {
		return new TNewsSrvUtil(NewsBase, ActivityBase); }

	PJsonVal Article(const TRec& ArticleRec, const bool& FullBodyP) const;
	PJsonVal Articles(const PRecSet& ArticleSet, const bool& FullBodyP,
		const TUInt64Set& IgnoreArticleSet = TUInt64Set()) const;
	PJsonVal FolderArticles(const PRecSet& ArticleSet, const int& Page=0, const int& Count=10) const;
};

///////////////////////////////////////////////
// PlusMachines-Server-Article
class TNewsSrvArticle : public TSAppSrvFun {
private:
	PNewsBase NewsBase;
	PNewsSrvUtil NewsSrvUtil;

public:
	TNewsSrvArticle(const PNewsBase& _NewsBase, const PNewsSrvUtil& _NewsSrvUtil);
	static PSAppSrvFun New(const PNewsBase& NewsBase, const PNewsSrvUtil& NewsSrvUtil) { 
		return new TNewsSrvArticle(NewsBase, NewsSrvUtil); }

	TStr ExecJSon(const TStrKdV& FldNmValPrV, const PSAppSrvRqEnv& RqEnv);
};


///////////////////////////////////////////////
// PlusMachines-Server-Folder
class TActivitySrv: public TSAppSrvFun {
private:
	PNewsBase NewsBase;
	PActivityBase ActivityBase;
	PNewsSrvUtil NewsSrvUtil;
public:
	TActivitySrv(const PNewsBase& _NewsBase, const PActivityBase& _ActivityBase, const PNewsSrvUtil& _NewsSrvUtil, const TStr& UrlStr): TSAppSrvFun(UrlStr, saotJSon), 
			NewsBase(_NewsBase), ActivityBase(_ActivityBase), NewsSrvUtil(_NewsSrvUtil) 
	{ 
	}
	static PSAppSrvFun New(const PNewsBase& NewsBase, const PActivityBase& ActivityBase, const PNewsSrvUtil& NewsSrvUtil, const TStr& UrlStr) { 
			return new TActivitySrv(NewsBase, ActivityBase, NewsSrvUtil, UrlStr); }

	TStr ExecJSon(const TStrKdV& FldNmValPrV, const PSAppSrvRqEnv& RqEnv);
	
	TStr GetStr(const TStrKdV& FldNmValPrV, const TStr& FldNm);
	TStr GetStrIfIn(const TStrKdV& FldNmValPrV, const TStr& FldNm, const TStr& DefVal);
	int GetInt(const TStrKdV& FldNmValPrV, const TStr& FldNm);
	int GetIntIfIn(const TStrKdV& FldNmValPrV, const TStr& FldNm, const int& DefVal);
	uint64 GetUInt64(const TStrKdV& FldNmValPrV, const TStr& FldNm);
	uint64 GetUInt64IfIn(const TStrKdV& FldNmValPrV, const TStr& FldNm, const uint64& DefVal);
	bool GetBoolIfIn(const TStrKdV& FldNmValPrV, const TStr& FldNm, const bool& DefVal);
	FolderVisibility GetVisibilityIfIn(const TStrKdV& FldNmValPrV, const FolderVisibility& DfVal);

		
	// folder functions
	PJsonVal ArticlesForFolder(const TStrKdV& FldNmValPrV);
	PJsonVal StoreArticleToFolder(const TStrKdV& FldNmValPrV);
	PJsonVal RemoveArticleFromFolder(const TStrKdV& FldNmValPrV);
	PJsonVal GetStoredArticleUris(const TStrKdV& FldNmValPrV);
	PJsonVal GetStoredArticles(const TStrKdV& FldNmValPrV);

	PJsonVal SaveLikedArticle(const TStrKdV& FldNmValPrV);
	PJsonVal UnlikeArticle(const TStrKdV& FldNmValPrV);
	PJsonVal GetLikedArticleUris(const TStrKdV& FldNmValPrV);

	PJsonVal AddFolder(const TStrKdV& FldNmValPrV);
	PJsonVal ModifyFolder(const TStrKdV& FldNmValPrV);
	PJsonVal RemoveFolder(const TStrKdV& FldNmValPrV);
	PJsonVal RemoveUser(const TStrKdV& FldNmValPrV);

	PJsonVal SaveActivityDataToFile(const TStrKdV& FldNmValPrV);
	PJsonVal LoadActivityDataFromFile(const TStrKdV& FldNmValPrV);
	
	PJsonVal GetStats(const TStrKdV& FldNmValPrV);
	PJsonVal PrintData(const TStrKdV& FldNmValPrV);
};