#ifndef CATEGORYREQ_H
#define CATEGORYREQ_H

#include "base.h"
#include "net.h"

class TEventRegBase;
typedef TPt<TEventRegBase> PEventRegBase;

ClassTPE(TCategoryReq, PCategoryReq, TWebPgFetch)//{
private:
	TStr CategorySrvUrl;
	TStr ReqSaveFName;
	TQQueue<TUInt64> ReqStoryIdQ;	 // order of the keys in which the requests should be processed
	TUInt64Set ReqStoryIdH;		    // keys -> request content
	TEventRegBase* EventRegBase;
	
	int CompletedCount;
	int ErrorCount;

	TCategoryReq(const TStr& SaveFName);
	~TCategoryReq();
	void Load();
	void Save();

	void PopReq();

	TCategoryReq(const TStr& _CategorySrvUrl, const TStr& _ReqSaveFName = "");

	void Report() { 
		printf("Category queue size: %6d. Completed: %6d. Failed: %6d\r", ReqStoryIdQ.Len(), CompletedCount, ErrorCount); 
	}

public:
	static PCategoryReq New(const TStr& CategorySrvUrl, const TStr& SaveFName = "") 
		{ return new TCategoryReq(CategorySrvUrl, SaveFName); }

	// set the event reg and then check if we have some waiting requests to process
	void SetEventRegBase(TEventRegBase* _EventRegBase) { 
		EventRegBase = _EventRegBase; 
		SendNextReq(); 
	}

	// set which method to call when we get a response from the category server
	//void SetCategoryResponseCallback(CategoryResponseFn CatResponseFn) { CategoryResponse = CatResponseFn; }

	void OnFetch(const int& FId, const PWebPg& WebPg);
	void OnError(const int& FId, const TStr& MsgStr);

	// send next request (if any is in the queue)
	void SendNextReq();

	// called to enquque next request
	void RequestStoryCategory(const uint64& StoryId);
};

#endif