
#ifndef USER_H
#define USER_H

#include <base.h>
#include <qminer.h>
#include "../NewsMiner/NewsConst.h"

using namespace TQm;

class TUser;
typedef TPt<TUser> PUser;
class TUser {
public:
	friend class TPt<TUser>;
private:
	TCRef CRef;

	TUser(const PJsonVal& Json);
	
	TUser(const uint64& UserId, const PStore& UserStore);
	
	static uint64 TimeStartMS;

public:
	// by default, Uri will be the SqlId of the user as assigned by the node.js
	TStr Uri;
	TStr Name;
	TFlt LastAccessTime;
	
	static PUser New(const PJsonVal& Json) { return new TUser(Json); }
	static PUser New() { return new TUser(TJsonVal::NewObj()); }
	static PUser New(const uint64& UserId, const PStore& UserStore);
	static PUser New(const TStr& UserNm, const PStore& UserStore);

	PJsonVal GetJson();	
	PJsonVal GetJsonForStore();

	static double GetTime();
};


#endif