#include <base.h>
#include <net.h>
#include "../NewsMiner/news.h"
#include "UserBase.h"

///////////////////////////////////////////////
// PlusMachines-Server-Helper-Utilities
ClassTP(TUserSrvUtil, PUserSrvUtil)//{
	// user base
	PUserBase UserBase;
	PStore UserStore;
	PStore ConceptFolderStore;

public:

	TUserSrvUtil(const PUserBase& _UserBase);
	static PUserSrvUtil New(const PUserBase& UserBase) {
		return new TUserSrvUtil(UserBase);
	}

	PJsonVal Folders(const PRecSet& FolderSet, const bool& IncludeFullInfo = false) const;
	PJsonVal Folder(const uint64& ConceptFolderId, const bool& IncludeFullInfo = false) const;
	
	PJsonVal User(const TStr& UserUri, const bool& IncludeFolderList = true, const bool& IncludeFullFolderInfo = false) const;
	PJsonVal User(const uint64& UserId, const bool& IncludeFolderList = true, const bool& IncludeFullFolderInfo = false) const;
	PJsonVal Users(const PRecSet& UserSet, const bool& IncludeFolderList = false, const bool& IncludeFullFolderInfo = false) const;
};

///////////////////////////////////////////////
// PlusMachines-Server-Folder
class TUsersSrv: public TSAppSrvFun {
private:
	PUserBase UserBase;
	PUserSrvUtil UserSrvUtil;

	TUsersSrv(const PUserBase& _UserBase, const PUserSrvUtil& _UserSrvUtil) : TSAppSrvFun("user", saotJSon),
		UserBase(_UserBase), UserSrvUtil(_UserSrvUtil) { }
public:
	
	static PSAppSrvFun New(const PUserBase& UserBase, const PUserSrvUtil& UserSrvUtil) { 
			return new TUsersSrv(UserBase, UserSrvUtil); }

	TStr ExecJSon(const TStrKdV& FldNmValPrV, const PSAppSrvRqEnv& RqEnv);
	
	uint64 GetUserId(const TStrKdV& FldNmValPrV);
	TStr GetUserSqlId(const TStrKdV& FldNmValPrV);
	uint64 GetConceptId(const TStrKdV& FldNmValPrV);
	uint64 GetSourceId(const TStrKdV& FldNmValPrV);
	uint64 GetArticleId(const TStrKdV& FldNmValPrV);
	
	// creating/modifying user
	PJsonVal AddUser(const TStrKdV& FldNmValPrV);
	PJsonVal SetUserName(const TStrKdV& FldNmValPrV);
	PJsonVal GetUserProfile(const TStrKdV& FldNmValPrV);
	//PJsonVal Profile(const TStrKdV& FldNmValPrV);
	
	// folder functions
	PJsonVal AddFolder(const TStrKdV& FldNmValPrV);
	PJsonVal UpdateFolder(const TStrKdV& FldNmValPrV);
	PJsonVal DeleteFolder(const TStrKdV& FldNmValPrV);
	PJsonVal GetFolderJson(const TStrKdV& FldNmValPrV);

	PJsonVal AddConceptToFolder(const TStrKdV& FldNmValPrV);
	PJsonVal RemoveConceptFromFolder(const TStrKdV& FldNmValPrV);
	PJsonVal LikeArticle(const TStrKdV& FldNmValPrV);
	
	// editing interests, relevant sources, relevant locations
	PJsonVal UpdateFolderWithArticleConcepts(const TStrKdV& FldNmValPrV);
		
	// search functions
	/*PJsonVal FindUsers(const TStrKdV& FldNmValPrV);
	PJsonVal FindFolders(const TStrKdV& FldNmValPrV);
	PJsonVal FindSimilarFolders(const TStrKdV& FldNmValPrV);
	*/
	// following friends
	PJsonVal FollowAdd(const TStrKdV& FldNmValPrV);
	PJsonVal FollowRemove(const TStrKdV& FldNmValPrV);
	
	// admin functionality (concept folders, ...)
	PJsonVal Users(const TStrKdV& FldNmValPrV);
	PJsonVal SaveUserDataToFile(const TStrKdV& FldNmValPrV);
	PJsonVal LoadUserDataFromFile(const TStrKdV& FldNmValPrV);
	PJsonVal ClearUserData(const TStrKdV& FldNmValPrV);
	PJsonVal GetStats(const TStrKdV& FldNmValPrV);
	PJsonVal PrintData(const TStrKdV& FldNmValPrV);

	// misc functionality
	uint64 UpdateFolderFromJson(const uint64& UserRecId, const uint64& FolderId, const PJsonVal& FolderJson);
	void GetArticleConceptsByType(const PJsonVal& ArticleJson, TUInt64FltKdV& EntityV, TUInt64FltKdV& TopicV, TUInt64FltKdV& ConceptFolderV, const bool& SortByWgts);
	//PJsonVal ParseInterests(const TStr& RqData);
};