#ifndef SENDARTICLETOCLUSTERING
#define SENDARTICLETOCLUSTERING

#include "../NewsMiner/NewsBase.h"
#include "../NewsMiner/NewsConst.h"
#include <qminer_core.h>
#include <qminer_srv.h>
#include <webpgfetchpersist.h>

ClassTPE(TClustReqPersist, PClustReqPersist, TWebPgFetchPersist)
protected:
	TStr ReportPrefix;

	TClustReqPersist(const TStr& _ReportPrefix = "", const TStr& _SaveFName = "", const bool& _RepeatFailedRequests = true, const bool& _ReportState = false, const PNotify& Notify = NULL) :
		TWebPgFetchPersist(_SaveFName, _RepeatFailedRequests, _ReportState, "", Notify), ReportPrefix(_ReportPrefix)
	{
		PutMxConns(1);
	}
public:
	static PClustReqPersist New(const TStr& ReportPrefix = "", const TStr& SaveFName = "", const bool& RepeatFailedRequests = true, const bool& ReportState = false, const PNotify& Notify = NULL) {
		return new TClustReqPersist(ReportPrefix, SaveFName, RepeatFailedRequests, ReportState, Notify);
	}

	/*void ReportError(const TStr& MsgStr) {
		printf("%sClustering Error: %s\n", ReportPrefix.CStr(), MsgStr.CStr());
	}*/
	void Report() {
		if (ReportState)
			printf("%sclustering queue size: %6d. Completed: %6d. Failed: %6d\r", ReportPrefix.CStr(), WaitFIdUrlPrL.Len(), SuccessCount.Val, ErrorCount.Val);
	}
};

ClassTP(TSendArticleToClustering, PSendArticleToClustering)//{
private:
	TStrV StoryUrlV;
	PNewsBase NewsBase;
	PBase Base;
	PStore ConceptStore;
	PStore ArticleStore;
		
	PNotify Notify;
	
	TStr SettingsFName;

	TFlt EntityWgt;
	TFlt NonEntityWgt;
	TBool MultiplyWithConceptWgts;

	// clustering web service
	TStrStrH LangStoryUrlH;
	// for calling web service
	THash<TStr, PClustReqPersist> StoryUrlToWebPgFetch;

	TSendArticleToClustering(const PNewsBase& _NewsBase, const TStr& _SettingsFName, const PNotify& Notify);

public:
	~TSendArticleToClustering() {};
	static PSendArticleToClustering New(const PNewsBase& NewsBase, const TStr& SettingsFName, const PNotify& Notify) {
		return new TSendArticleToClustering(NewsBase, SettingsFName, Notify);
	}

	void SendArticle(const uint64& ArticleId);
	void SetStoryUrlV(const TStrV& _StoryUrlV, const TStr& WebReqFName);
	PNotify GetNotify() { return Notify; }
	void Report() {
		for (int KeyId = StoryUrlToWebPgFetch.FFirstKeyId(); StoryUrlToWebPgFetch.FNextKeyId(KeyId);) {
			StoryUrlToWebPgFetch[KeyId]->Report();
		}
	}
};


///////////////////////////////
// Add article - "add" method, recieving binary data
class TAddArticleSrv : public TSrvFun {
private:
	// base
	PNewsBase NewsBase;
	// clustering web service
	TStrStrH LangStoryUrlH;
	// for calling web service
	PSendArticleToClustering SendArticleToClustering;

public:
	// no forward
	TAddArticleSrv(const PNewsBase& _NewsBase, const PSendArticleToClustering& SendArticleToClustering);
	static PSAppSrvFun New(const PNewsBase& NewsBase, const PSendArticleToClustering& SendArticleToClustering) {
		return new TAddArticleSrv(NewsBase, SendArticleToClustering);
	}

	PXmlDoc ExecXml(const TStrKdV& FldNmValPrV, const PSAppSrvRqEnv& RqEnv);
};

///////////////////////////////
// Add article json - "addJson" method, recieving json array of articles to add
class TAddArticleJsonSrv : public TSrvFun {
private:
	// base
	PNewsBase NewsBase;
	// clustering web service
	TStrStrH LangStoryUrlH;
	// for calling web service
	PSendArticleToClustering SendArticleToClustering;

public:
	// no forward
	TAddArticleJsonSrv(const PNewsBase& _NewsBase, const PSendArticleToClustering& SendArticleToClustering);
	static PSAppSrvFun New(const PNewsBase& NewsBase, const PSendArticleToClustering& SendArticleToClustering) {
		return new TAddArticleJsonSrv(NewsBase, SendArticleToClustering);
	}

	PXmlDoc ExecXml(const TStrKdV& FldNmValPrV, const PSAppSrvRqEnv& RqEnv);
};



#endif