#ifndef ADDSTORYSRV_H
#define ADDSTORYSRV_H

#include "../ServerArticles/EventRegBase.h"

// clustUtil knows how to process all information related to assigning articles to stories, setting duplicates, etc
// these methods can be called from an external clustering instance or by a local clustering
class TClustUtil
{
private:

public:
	TNewsBase* NewsBase;
	TEventRegBase* EventRegBase;

	TClustUtil(TNewsBase* _NewsBase, TEventRegBase* _EventRegBase);

	void SetArticle(const TStr& ArticleName, const TStr& StoryName, const double& CosToCentroid);
	void SetDuplicate(const TStr& ArticleName, const TStr& OriginalArticleName);
	void SetClusterInfo(const TStr& MedoidArticleName, const TStr& StoryName, const TStrV& ArticleNameV, const TFltV& CosToCentroidV, const TFlt& Variance, const TFlt& AvgCosToCentroid);
	void MarkArticlesStoryless(const TStr& StoryName, const TStrV& ArticleNameV);
	void SetClusterDeleted(const TStr& StoryName);
};


class TAddStorySrv : public TSAppSrvFun {
private:
	TClustUtil* ClustUtil;
	TNewsBase* NewsBase;
	TEventRegBase* EventRegBase;

	TAddStorySrv(TClustUtil* _ClustUtil) : ClustUtil(_ClustUtil), TSAppSrvFun("add-story", saotJSon)
	{ 
		NotifyOnRequest = false;	// don't log requests
		LogRqToFile = false;		// don't save files with request content - makes processing clustering requests extremely slow!
		NewsBase = ClustUtil->NewsBase;
	};
public:
	static PSAppSrvFun New(TClustUtil* ClustUtil) { return new TAddStorySrv(ClustUtil); }

	TStr ExecJSon(const TStrKdV& FldNmValPrV, const PSAppSrvRqEnv& RqEnv);
};

#endif