#ifndef CATEGORYSRV_H
#define CATEGORYSRV_H

#include <qminer_srv.h>
#include "../NewsMiner/NewsBase.h"
#include "../NewsMiner/NewsSrvUtil.h"
#include "../NewsMiner/CategoryBase.h"

///////////////////////////////////////////////
// PlusMachines-Server-Article
class TCategorySrv : public TSAppSrvFun {
private:
	PNewsBase NewsBase;
	PNewsSrvUtil NewsSrvUtil;
	PCategoryBase CategoryBase;

	TCategorySrv(const PNewsBase& _NewsBase, const PNewsSrvUtil& _NewsSrvUtil);

public:
	static PSAppSrvFun New(const PNewsBase& NewsBase, const PNewsSrvUtil& NewsSrvUtil) { 
		return new TCategorySrv(NewsBase, NewsSrvUtil); }

	TStr ExecJSon(const TStrKdV& FldNmValPrV, const PSAppSrvRqEnv& RqEnv);
	
	PJsonVal PerformAction(const TStrKdV& FldNmValPrV, const PSAppSrvRqEnv& RqEnv);
	
	// go over each child in the CatArray array and add "children" field with array of it's children (or add nothing if no children)
	void AddSubChildren(PJsonVal& CatArray);
};

class TCategoryAutoSuggestSrv : public TSAppSrvFun {
private:
	PNewsBase NewsBase;
	PNewsSrvUtil NewsSrvUtil;
	PCategoryBase CategoryBase;

	TInt CachedCategoryCount;
	THash<TStr, TVec<TUInt64IntKd> > CategoryPrefixToIdWgtH;

	TCategoryAutoSuggestSrv(const PNewsBase& _NewsBase, const PNewsSrvUtil& _NewsSrvUtil);
	~TCategoryAutoSuggestSrv();

public:
	static TCategoryAutoSuggestSrv* New(const PNewsBase& NewsBase, const PNewsSrvUtil& NewsSrvUtil) {
		return new TCategoryAutoSuggestSrv(NewsBase, NewsSrvUtil);
	}

	TStr ExecJSon(const TStrKdV& FldNmValPrV, const PSAppSrvRqEnv& RqEnv);

	void LoadOrUpdatePrefixes();
	void UpdatePrefixes();
	PJsonVal FindCategories(const TStrKdV& FldNmValPrV);
	void GetCategorySuggestions(const TStr& Prefix, TVec<TUInt64IntKd>& SuggV) const;
};

#endif