#ifndef CONCEPTFOLDERSRV_H
#define CONCEPTFOLDERSRV_H

#include <net.h>
#include "../NewsMiner/NewsBase.h"
#include "../NewsMiner/ConceptFolderBase.h"
#include "../NewsMiner/NewsSrvUtil.h"



class TConceptFolderSrv : public TSAppSrvFun {
private:
	PNewsBase NewsBase;
	PConceptFolderBase ConceptFolderBase;
	PNewsSrvUtil NewsSrvUtil;

public:
	TConceptFolderSrv(const PNewsBase& _NewsBase, const PConceptFolderBase _ConceptFolderBase, const PNewsSrvUtil& _NewsSrvUtil, const bool& _LogRqToFile) :
		TSAppSrvFun("conceptFolder", saotJSon), NewsBase(_NewsBase), ConceptFolderBase(_ConceptFolderBase), NewsSrvUtil(_NewsSrvUtil)
	{
		LogRqToFile = _LogRqToFile;
	}
	static PSAppSrvFun New(const PNewsBase& NewsBase, const PConceptFolderBase& ConceptFolderBase, const PNewsSrvUtil& NewsSrvUtil, const bool& LogRqToFile) {
		return new TConceptFolderSrv(NewsBase, ConceptFolderBase, NewsSrvUtil, LogRqToFile);
	}

	TStr ExecJSon(const TStrKdV& FldNmValPrV, const PSAppSrvRqEnv& RqEnv);

	PJsonVal GetArticles(const TStrKdV& FldNmValPrV);
	PJsonVal GetEvents(const TStrKdV& FldNmValPrV);
	PJsonVal GetArticlesForFolder(const TStrKdV& FldNmValPrV);
	PJsonVal GetEventsForFolder(const TStrKdV& FldNmValPrV);

	PJsonVal GetFolderJson(const TStrKdV& FldNmValPrV);

	PJsonVal AddLabelsForFolderJson(const TStrKdV& FldNmValPrV);
	PJsonVal AddConceptDetailsFolderJson(const TStrKdV& FldNmValPrV);

	PJsonVal ListFolders(const TStrKdV& FldNmValPrV);
};

#endif
