#ifndef CONCEPTSRV_H
#define CONCEPTSRV_H

#include <net.h>
#include <base.h>
#include "../NewsMiner/NewsConst.h"
#include "../NewsMiner/NewsSearch.h"
#include "../NewsMiner/NewsSrvUtil.h"


///////////////////////////////////////////////
// concept server
class TConceptSrv : public TSAppSrvFun {
private:
	PNewsBase NewsBase;
	PNewsSearch NewsSearch;
	PNewsSrvUtil NewsSrvUtil;

public:
	TConceptSrv(const PNewsBase& _NewsBase, const PNewsSearch& NewsSearch, const PNewsSrvUtil& _NewsSrvUtil);

	static PSAppSrvFun New(const PNewsBase& NewsBase, const PNewsSearch& NewsSearch, const PNewsSrvUtil& NewsSrvUtil) {
		return new TConceptSrv(NewsBase, NewsSearch, NewsSrvUtil);
	}

	TStr ExecJSon(const TStrKdV& FldNmValPrV, const PSAppSrvRqEnv& RqEnv);

	PJsonVal GetArticles(const TStrKdV& FldNmValPrV);
	PJsonVal GetInfo(const TStrKdV& FldNmValPrV);
	PJsonVal GetRelatedConcepts(const TStrKdV& FldNmValPrV);
};


#endif
