/**
 * Author: Gregor Leban <gleban@gmail.com>
 * Copyright (c) 2015, Jozef Stefan Institute, Quintelligence d.o.o. and contributors
 * All rights reserved.
 *
 * This source code is licensed under the FreeBSD license found in the
 * LICENSE file in the root directory of this source tree.
 */
#include "ConceptTrendsSrv.h"
#include "../NewsMiner/NewsConst.h"


// //////////////
// TConceptTrendsSrv web service
TStr TConceptTrendsSrv::ExecJSon(const TStrKdV& FldNmValPrV, const PSAppSrvRqEnv& RqEnv)
{
	PJsonVal ResJson = NULL;
	try {
		TStr Action = GetFldVal(FldNmValPrV, "action", "");
		if (Action == "getTrends")
			ResJson = GetTrends(FldNmValPrV);
		else
			ResJson = TJsonVal::NewObj("error", TStr::Fmt("Unknown action '%s' provided. Known actions are getTrends", Action.CStr()));
	}
	catch (PExcept E) {
		ResJson = TJsonVal::NewObj();
		ResJson->AddToObj("error", TJsonVal::NewStr(E->GetMsgStr()));
		TNotify::StdNotify->OnStatus("Error: " + E->GetMsgStr());
	}
	// handle jsonP requests
	if (IsFldNm(FldNmValPrV, "callback")) {
		TStr Callback = GetFldVal(FldNmValPrV, "callback", "");
		return Callback + "(" + TJsonVal::GetStrFromVal(ResJson) + ")";
	}
	else
		return TJsonVal::GetStrFromVal(ResJson);
}


PJsonVal TConceptTrendsSrv::GetTrends(const TStrKdV& FldNmValPrV)
{
	//TInt IgnoreTestConceptsBelowFq = GetFldInt(FldNmValPrV, "ignoreTestConceptsBelowFq", 100);
	//TInt IgnoreNullConceptsBelowFq = GetFldInt(FldNmValPrV, "ignoreNullConceptsBelowFq", 100);
	//TInt Count = GetFldInt(FldNmValPrV, "count", 20);

	//TStrV TestPopKeyV, NullPopKeyV;
	//if (IsFldNm(FldNmValPrV, "testPopOffs")) {
	//	TStr TestOffDesc = GetFldVal(FldNmValPrV, "testPopOffs", "D0");
	//	TestPopKeyV = TrendsManager->GetPopKeysForOffDesc(TestOffDesc);
	//}
	//else if (IsFldNm(FldNmValPrV, "testPopKeys")) {
	//	TStr TestKeys = GetFldVal(FldNmValPrV, "testPopKeys", "");
	//	TestKeys.SplitOnAllCh(',', TestPopKeyV);
	//}
	//if (IsFldNm(FldNmValPrV, "nullPopOffs")) {
	//	TStr NullOffDesc = GetFldVal(FldNmValPrV, "nullPopOffs", "Total");
	//	NullPopKeyV = TrendsManager->GetPopKeysForOffDesc(NullOffDesc);
	//}
	//else if (IsFldNm(FldNmValPrV, "nullPopKeys")) {
	//	TStr NullKeys = GetFldVal(FldNmValPrV, "nullPopKeys", "");
	//	NullKeys.SplitOnAllCh(',', NullPopKeyV);
	//}

	//if (TestPopKeyV.Len() == 0)
	//	return TJsonVal::NewObj("error", TStr("testPopOffs and testPopKeys did not contain any valid values for a population. Values should be of type 'Total', 'Y0', 'M1' or 'D2' or a comma separated list of them, like 'M1,M2,M3'."));
	//if (NullPopKeyV.Len() == 0)
	//	return TJsonVal::NewObj("error", TStr("nullPopOffs and nullPopKeys did not contain any valid values for a population. Values should be of type 'Total', 'Y0', 'M1' or 'D2' or a comma separated list of them, like 'M1,M2,M3'."));

	//PConceptPop TestPop = TrendsManager->GetPopForKeys(TestPopKeyV);
	//PConceptPop NullPop = TrendsManager->GetPopForKeys(NullPopKeyV);
	//PConceptTrends Trends = TrendsManager->ComparePops(TestPop, NullPop, IgnoreTestConceptsBelowFq, IgnoreNullConceptsBelowFq);
	//if (Trends.Empty())
	//	return TJsonVal::NewObj("error", TStr("Unknown error. Unable to obtain trends given the null and test populations."));

	//TStrV ConceptTypesV; GetFldValV(FldNmValPrV, "conceptType", ConceptTypesV);		// which concept types should be included
	//if (ConceptTypesV.Len() == 0) {
	//	ConceptTypesV.Add(NewsConst.TypeLocation);
	//	ConceptTypesV.Add(NewsConst.TypeOrganization);
	//	ConceptTypesV.Add(NewsConst.TypePerson);
	//}
	//TStrSet ConceptTypeSet(ConceptTypesV);

	PJsonVal Json = TJsonVal::NewObj();
	/*Json->AddToObj("testTotal", (int) Trends->GetTestPop()->GetTotalCount());
	Json->AddToObj("nullTotal", (int) Trends->GetNullPop()->GetTotalCount());
	PJsonVal Arr = TJsonVal::NewArr();
	Json->AddToObj("trends", Arr);
	TJsonValV JsonV;
	for (int N = 0, Added = 0; N < Trends->Len() && Added < Count; N++) {
		uint64 ConceptId = (uint64) Trends->GetTopConceptId(N);
		if (ConceptTypeSet.IsKey(NewsBase->ConceptStore->GetFieldNmStr(ConceptId, "Type"))) {
			PJsonVal Trend = Trends->GetConceptJson(N);
			Trend->AddToObj("uri", NewsBase->ConceptStore->GetRecNm(ConceptId));
			Trend->AddToObj("label", NewsBase->ConceptStore->GetFieldNmStr(ConceptId, "Label"));
			Arr->AddToArr(Trend);
			Added++;
		}
	}*/
	return Json;
}
