#ifndef STORYLINKINGSRV_H
#define STORYLINKINGSRV_H

#include <base.h>
#include <net.h>
#include "../NewsMiner/NewsBase.h"
#include "../ServerArticles/EventRegBase.h"
#include "../NewsMiner/NewsSrvUtil.h"

//////////////////////////////////////
class TStoryLinkingSrv : public TSAppSrvFun {
private:
	PNewsBase NewsBase;
	PEventRegBase EventRegBase;
	PStoryLinking StoryLinking;
	PNewsSrvUtil NewsUtil;
	TRnd Rnd;

	TStoryLinkingSrv(const PNewsBase& _NewsBase, const PEventRegBase& _EventRegBase, const PNewsSrvUtil& _NewsUtil, const bool _LogRqToFile = false);

	TStr ExecJSon(const TStrKdV& FldNmValPrV, const PSAppSrvRqEnv& RqEnv);

	PJsonVal GetStoryPair(const TStrKdV& FldNmValPrV);
	PJsonVal SuggestStoryPair(const TStrKdV& FldNmValPrV);
	PJsonVal SetClassForStoryPair(const TStrKdV& FldNmValPrV);
	PJsonVal BuildModel(const TStrKdV& FldNmValPrV);
	PJsonVal SaveData(const TStrKdV& FldNmValPrV);
	PJsonVal RebuildData(const TStrKdV& FldNmValPrV);
	PJsonVal PredictForStoryPair(const TStrKdV& FldNmValPrV);
	
	PJsonVal StoryPair(const TStrKdV& FldNmValPrV, const uint64& StoryId1, const uint64& StoryId2);

public:
	static PSAppSrvFun New(const PNewsBase& NewsBase, const PEventRegBase& EventRegBase, const PNewsSrvUtil& NewsUtil, const bool LogRqToFile = false) {
		return new TStoryLinkingSrv(NewsBase, EventRegBase, NewsUtil, LogRqToFile);
	}
};

#endif