#ifndef STORYSRV_H
#define STORYSRV_H

#include <base.h>
#include "../NewsMiner/NewsBase.h"
#include "../NewsMiner/NewsCounts.h"
#include "../NewsMiner/NewsSrvUtil.h"
#include "../ServerArticles/EventRegBase.h"

///////////////////////////////////////////////
// story server
class TStorySrv : public TSAppSrvFun {
private:
	PNewsBase NewsBase;
	PEventRegBase EventRegBase;
	PNewsSrvUtil NewsSrvUtil;

public:
	TStorySrv(const PNewsBase& _NewsBase, const PEventRegBase& _EventRegBase, const PNewsSrvUtil& _NewsSrvUtil);

	static PSAppSrvFun New(const PNewsBase& NewsBase, const PEventRegBase& EventRegBase, const PNewsSrvUtil& NewsSrvUtil) {
		return new TStorySrv(NewsBase, EventRegBase, NewsSrvUtil);
	}

	TStr ExecJSon(const TStrKdV& FldNmValPrV, const PSAppSrvRqEnv& RqEnv);

	PJsonVal GetStory(const TStrKdV& FldNmValPrV);
	PJsonVal GetArticlesRelatedToStory(const TStrKdV& FldNmValPrV);

private:
	PJsonVal GetSingleStory(const TStrKdV& FldNmValPrV, const TStr& StoryUri);
	PJsonVal SimilarStories(const TStrKdV& FldNmValPrV, const TStr& StoryUri);
};


#endif