/**
 * Author: Gregor Leban <gleban@gmail.com>
 * Copyright (c) 2015, Jozef Stefan Institute, Quintelligence d.o.o. and contributors
 * All rights reserved.
 *
 * This source code is licensed under the FreeBSD license found in the
 * LICENSE file in the root directory of this source tree.
 */
#include "FileUtils.h"

//////////////////////////////////////
// File-Notify
TFileNotifyNoTime::TFileNotifyNoTime(const TStr& _FileName) : FileName(_FileName) { 
	File = TFOut::New(_FileName, true);
}

void TFileNotifyNoTime::OnStatus(const TStr& MsgStr) {
	File->PutStrFmt("%s\n", 
		MsgStr.CStr());
	File->Flush();
}

void TFileNotifyNoTime::OnNotify(const TNotifyType& Type, const TStr& MsgStr){
	TStr TypeStr = "";
	if (Type==ntInfo) TypeStr = "INFO";
	else if (Type == ntErr) TypeStr = "ERROR";
	else if (Type == ntWarn) TypeStr = "WARNING";
	else if (Type == ntStat) TypeStr = "STAT";

	TTm NowTm = TTm::GetCurLocTm();
	
	File->PutStrFmt("%s: %s\n", 
		TypeStr.CStr(),
		MsgStr.CStr());
	File->Flush();
}

TFileNotifyNoTime* FileUtils::FileNotify = NULL;

// if CommentPrefix != "" then all lines starting with CommentPrefix will be ignored and not read
//TStr FileUtils::ReadTextFile(const TStr& FileName, const TStr& DefVal, const TStr& CommentPrefix)
//{
//	try 
//	{
//		TFIn FIn(FileName);
//		TChA Content;
//		while (true) {
//			TStr Line;
//			bool ok = FIn.GetNextLn(Line);
//			if (!ok)
//				break;
//			if (CommentPrefix != "" && Line.SearchStr(CommentPrefix) == 0)
//				continue;
//			Content += Line;
//		}
//		return Content;
//	}
//	catch (PExcept E)
//	{
//		return DefVal;
//	}
//}



