#ifndef VALIDATEDARTICLELINKS
#define VALIDATEDARTICLELINKS

#include <base.h>

class TNewsBase;
typedef TPt<TNewsBase> PNewsBase;

class TValidatedArticleLinks;
typedef TPt<TValidatedArticleLinks> PValidatedArticleLinks;

class TValidatedArticleLinks
{
private:
	TCRef CRef;
private:
	friend class TPt<TValidatedArticleLinks>;

	TStr FName;
	THash<TUInt64, TUInt64> ArticleToStoryIdH;		// ArticleId -> StoryId (article is validated to belong to given story)
	
	TValidatedArticleLinks(const TStr& FNamePath);

public:
	static PValidatedArticleLinks New(const TStr& FName) { return new TValidatedArticleLinks(FName); }
	~TValidatedArticleLinks();

	void Load();
	void Save() const;
	void SaveToJson(const TStr& OutFNm, const PNewsBase& NewsBase) const;
	void LoadFromJson(const TStr& InFNm, const PNewsBase& NewsBase);

	// set the article -> story link. if article was just removed from the story then set it to ::Mx
	void SetArticleToStoryLink(const uint64& ArticleId, const uint64& StoryId = TUInt64::Mx);
	bool HasStoryForArticle(const uint64& ArticleId) const;
};

#endif