#ifndef VALIDATEDSTORYLINKS
#define VALIDATEDSTORYLINKS

#include <base.h>

class TValidatedStoryLinks;
typedef TPt<TValidatedStoryLinks> PValidatedStoryLinks;


class TValidatedStoryLinks
{
private:
	TCRef CRef;
private:
	friend class TPt<TValidatedStoryLinks>;

	TStr FName;
	THash<TUInt64, TUInt64V> ValidatedSameEventH;	// StoryId -> StoryIdV  (story is validated to belong to SAME event as stories in StoryIdV)
	THash<TUInt64, TUInt64V> ValidatedDiffEventH;	// StoryId -> StoryIdV  (story is validated to belong to DIFFERENT event as stories in StoryIdV)

	TValidatedStoryLinks(const TStr& FNamePath);

public:
	static PValidatedStoryLinks New(const TStr& FName) { return new TValidatedStoryLinks(FName); }
	~TValidatedStoryLinks();

	void Load();
	void Save();
	void SaveToJson(const TStr& OutFNm);
	void LoadFromJson(const TStr& InFNm);

	void AddCuratedStoryMergeInfo(const uint64& StoryId1, const uint64& StoryId2, const bool& ShouldMerge);

	TUInt64V GetValidatedDiffEvents(const uint64& StoryId);
	TUInt64V GetValidatedSameEvents(const uint64& StoryId);
};


#endif